/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id:
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СmindstormsNXTѡ
 */

#include "tSIOPortMindstormsNXT_tecsgen.h"
#include "target_serial.h"
#include "at91sam7s.h"
#include <t_stddef.h>
#include <t_syslog.h>

#include "ecrobot_interface.h"
#include "ecrobot_bluetooth.h"

#include "kernel_cfg.h"

/*
 *  Хåեơѥ桼ƥƥ
 */
inline void
rot_target_send_buf(CELLCB *p_cellcb)
{
	if(VAR_sendBufferPointer == VAR_sendBuffer1) {
		VAR_sendBufferPointer = VAR_sendBuffer2;
	} else {
		VAR_sendBufferPointer = VAR_sendBuffer1;
	}
}

/*
 * ʸ?
 * TODO: ̤
 * bluetooth̿ˤϥǡƬ˥2ХɲäʤȤʤ
 *  RXBUFF?  Хåեե
 */ 
Inline bool_t
uart_getready(CELLCB *p_cellcb)
{
//    return(((sil_rew_mem((void*)(ATTR_uartBase+TOFF_US_CSR)) & US_RXRDY)!=0));
}

/*
 *  DMAž椫?
 *  DMAžʤfalseǤʤtrue֤
 */
Inline bool_t
uart_puts_ready(CELLCB *p_cellcb)
{
	return (sil_rew_mem((void*)(ATTR_uartBase+TOFF_PDC_TNCR)) == 0);
}

/*
 *  ʸμФ
 * TODO: ̤
 * bluetooth̿ˤϥǡƬ˥2ХɲäʤȤʤ
 */
Inline uint8_t
uart_getchar(CELLCB *p_cellcb)
{
/* 	uint8_t rcv_buf;
 * 	
 * 	while(ecrobot_read_bt_packet(&rcv_buf, 1) == 0) {
 * 		dly_tsk(10);
 * 	}
 * 	return rcv_buf;
 */
	
    //return(sil_rew_mem((void*)(ATTR_uartBase+TOFF_US_RHR)));
}

/* 
 *  DMAž
 */
Inline void
uart_puts(CELLCB *p_cellcb)
{
	/*
	 * 	bluetoothȤϡǡƬ˥ɲäɬפ
	 */
	VAR_sendBufferPointer[0] = (uint8_t)(VAR_sendBufferCount & 0xFF);
	VAR_sendBufferPointer[1] = (uint8_t)((VAR_sendBufferCount >> 8) & 0xFF);

	/*
	 *  DMAȥˡǡΥɥ쥹ȥΤ餻
	 */
	sil_wrw_mem((void*)(ATTR_uartBase+TOFF_PDC_TNPR), (uint_t)VAR_sendBufferPointer);
    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_PDC_TNCR), VAR_sendBufferCount);
}

/*
 *  ߵ
 *  Хåե
 */
Inline void
uart_enable_send(CELLCB *p_cellcb)
{
    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IER), US_TXBUFE);
}

/*
 *  ߶ػ
 *  Хåե
 */
Inline void
uart_disable_send(CELLCB *p_cellcb)
{
	sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IDR), US_TXBUFE);
}


/*
 *  ߵ
 *  TODO: ̤
 *  bluetooth̿ˤϥǡƬ˥2ХɲäʤȤʤ
 *  RXBUFF?  Хåեե
 */
Inline void
uart_enable_rcv(CELLCB *p_cellcb)
{
//    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IER), US_RXRDY);
}

/*
 *  ߶ػ
 *  TODO: ̤
 *  bluetooth̿ˤϥǡƬ˥2ХɲäʤȤʤ
 *  RXBUFF?  Хåեե
 */
Inline void
uart_disable_rcv(CELLCB *p_cellcb)
{
//    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IDR), US_RXRDY);
}


/*
 *  SIOɥ饤Фν
 *
 *  ֥åνǽפˤʤ롥
 */
void
eInitialize_main(CELLIDX idx)
{
	CELLCB	*p_cellcb = (CELLCB *) idx;
	/*
	 *  ꥢI/OݡȤν
	 */
	VAR_openFlag = false;
	VAR_sendBufferPointer = VAR_sendBuffer1;
	VAR_sendBufferCount = 2U;
}

/*
 *  SIOɥ饤Фνλ
 */
void
eTerminate_main(CELLIDX idx)
{
	CELLCB	*p_cellcb = (CELLCB *) idx;

	/*
	 *  ץ󤵤Ƥ륷ꥢI/OݡȤΥ
	 */
	if (VAR_openFlag) {
		/*
		 *  饤֥¦ǽλԤ
		 */
		VAR_openFlag = false;
		/*
		 *  ꥢI/Oߤޥ롥
		 */
		dis_int(INTNO_SIO);
	}
}

/*
 *  ꥢI/OݡȤΥץ
 */
void
eSIOPort_open(CELLIDX idx)
{
	CELLCB			*p_cellcb;
	bool_t opnflg;
	
	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	opnflg = VAR_openFlag;
	
	VAR_openFlag = true;

	if(!opnflg) {
		ena_int(INTNO_SIO);
	}

	uart_enable_rcv(p_cellcb); /* ߤĤ: ̤ */
}

/*
 *  ꥢI/OݡȤΥ
 */
void
eSIOPort_close(CELLIDX idx)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	sil_wrw_mem((void *)(ATTR_uartBase + TOFF_US_CR), US_RSTRX|US_RSTTX|US_RXDIS|US_TXDIS);
	
	VAR_openFlag = false;

	dis_int(INTNO_SIO);
}

/*
 *  SIOγߥӥ롼
 *  mindstormsNXTǤbluetooth³ƤUARTΥݡȤ1
 *  ʤᡤ٥ϤȥޥեԤ򤹤ϤUART
 *  ݡȤͭƤ롥
 *  ߥϥɥDMAž򳫻Ϥʤȡ٥ϤDMAž
 *  ޥեԤ򤹤ϤDMAžȤξͤǽ롥
 *  â٥ϤDMAžԤȡޥեԤ򤹤Ϥ
 *  DMAžԤƱ˵ȡ٥ϤDMAž1ʬ
 *  ٤ǽ롥
 */
void
eiISR_main(CELLIDX idx)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	if (uart_puts_ready(p_cellcb)) { // DMAžä
		uart_disable_send(p_cellcb); // ߶ػ
		ciSendSemaphore_signal();    // DMAѥޥեֵ
		uart_puts(p_cellcb);         // DMAžϤ
	}
	if (uart_getready(p_cellcb)) {   // TODO: ̤
		ciSIOCBR_readyReceive();
	}
}


/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
eSIOPort_putChar(CELLIDX idx, char_t c)
{
	CELLCB	*p_cellcb;
	int_t	n;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	if(ecrobot_get_bt_status() != BT_STREAM) { // bluetooth³ƤʤǤʤ
		return true; // ⤷ʤ
	}
	
	VAR_sendBufferPointer[VAR_sendBufferCount] = c; // Хåեʸ
	VAR_sendBufferCount++;                        // Хåեʸ򥤥󥯥

	if(c == '\n' || VAR_sendBufferCount >= ATTR_sendBufferSize) { // ʸξ or Хåեեξ
		
		if(uart_puts_ready(p_cellcb)) { // ǽɤå
			uart_puts(p_cellcb);        // DMAžϤ

		} else {                        // DMAž
			uart_enable_send(p_cellcb); // ߵ
			
			cSendSemaphore_wait();      // ISRDMAžϤޤԤ
		}
		
		rot_target_send_buf(p_cellcb);  // Хåեؤ
		VAR_sendBufferCount = 2U;        // Хåեʸꥻå
	}

	return true;
}

/*
 *  ꥢI/OݡȤʸ
 *  TODO: ̤
 *  bluetooth̿ˤϥǡƬ˥2ХɲäʤȤʤ
 */
int_t
eSIOPort_getChar(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	char_t	c;
	int_t	n;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

//    if (uart_getready(p_cellcb)) { // TODO: ̤
/*     {
 *         return((int_t)(uint8_t) uart_getchar(p_cellcb));
 *     }
 *     return(false);
 */
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
eSIOPort_enableCBR(CELLIDX idx, uint_t cbrtn)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	switch (cbrtn) {
	case SIO_RDY_RCV:
		uart_enable_rcv(p_cellcb);
		break;
	}
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
eSIOPort_disableCBR(CELLIDX idx, uint_t cbrtn)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	switch (cbrtn) {
	case SIO_RDY_RCV:
		uart_disable_rcv(p_cellcb);
		break;
	}
}
