/*
	target_entry_point.S

	vOFLASHRAMɃ[h

	ertl-ishikawa
*/

/*--------------------------------------------------------------------*/

	.global Target_Entry_Point

	.text
	.code 32
	.align 	2

#define RAM_START 0x00020000

/*
 * r0: vOFLASHł̃AhX
 * r1: t@CTCY
 */
Target_Entry_Point:

	/* globally disable interrupts */
	STMDB	sp!, {r0}		/* Push r0						*/
	MRS	r0, CPSR			/* Get CPSR						*/
	ORR	r0, r0, #0xC0		/* Disable IRQ, FIQ				*/
	MSR	CPSR, r0			/* Write back modified value	*/
	LDMIA	sp!, {r0}		/* Pop r0						*/

	add	r2, r0, r1      /* r2 : vȌI[Ԓn */
	mov	r1, #RAM_START	/* r1 : RAM̐擪Ԓn */
 	add	r0, r0, #16	    /* wb_͔΂ (12 + 4 byte) */

CopyToRAM:
	cmp r0, r2             /* I */
	beq JumpToResetVector
	ldr r3, [r0], #4       /* FLASH */
	str r3, [r1], #4       /* RAM     */
	b CopyToRAM
	
JumpToResetVector:
 	mov	PC, #RAM_START /* ZbgxN^RAM̐擪ɒuĂ */

