#ifndef __cygwin_tecs_h__
#define __cygwin_tecs_h__

#include "kernel.h"

#ifdef INT_LEAST128_MAX
typedef int_least128_t tecs_int128;
typedef uint_least128_t tecs_uint128;
#else
typedef struct { int64_t high; uint64_t low; } int128_t;
typedef struct { uint64_t high; uint64_t low; } uint128_t;
#endif

#define E_RPC     (-67)
#define E_RESET   (-68)
#define E_MAGIC   (-69)

#endif /* __cygwin_tecs_h__ */


