/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tSocketClient_template.c => src/tSocketClient.c
 * Τ褦̾, եѹƤ齤ޤ
 *
 * °ޥ #_CAAM_#
 * port_no          int16_t          ATTR_port_no    
 * sd               int_t            VAR_sd          
 *
 * #[</PREAMBLE>]# */

#include "tSocketClient_tecsgen.h"

#include <errno.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include <unistd.h>

#ifndef E_OK
#define	E_OK	0		/* ｪλ */
#define	E_ID	(-18)	/* IDֹ */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eC0
 * entry port: eC0
 * signature:  sChannel
 * context:    task
 * params: 
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eC0_open
 * name:         eC0_open
 * global_name:  tSocketClient_eC0_open
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC0_open(CELLIDX idx, const int8_t* arg, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	int soc;
	struct sockaddr_in addr={AF_INET};

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	soc=socket(AF_INET, SOCK_STREAM, 0);
	if(soc<0){
		syslog( LOG_INFO, "SocketClient: socket failed");
		return E_RPC;
	}

#if 0
/* Υ֥åѹ */
	int flag=fcntl(soc, F_GETFL, 0);
	if(flag<0) perror("fcntl(GET) error");
	if(fcntl(soc, F_SETFL, flag|O_NONBLOCK)<0) perror("fcntl(NONBLOCK) error");
#endif /* 0 */

#define SERVER_IP_ADDR "127.0.0.1"
#define SERVER_PORT_NO (8931)

	// addr.sin_addr.s_addr=inet_aton( SERVER_IP_ADDR );
	inet_aton( SERVER_IP_ADDR, &addr.sin_addr );
	addr.sin_port=htons(SERVER_PORT_NO);
	if(connect(soc, (struct sockaddr*)&addr, sizeof(addr))<0){
		close( soc );
		syslog( LOG_INFO, "SocketClient: connect" );
		return E_RPC;
	}
	VAR_sd = soc;

#if 0
	if(errno!=EINPROGRESS)
		perror("connect error");
	//EINPROGRESS:ͥ׵ϻϤޤäޤλƤʤ

	fd_set rmask,wmask;FD_ZERO(&rmask);FD_SET(soc,&rmask);wmask=rmask;
	struct timeval tv={ ॢȻ[],[] };
	int rc=select(soc+1, &rmask, &wmask, NULL, &tv);
	if(rc<0) perror("connect-select error");
	if(rc==0){ ॢȽ }
	if(rc==2){ //ɤ߽񤭤Ʊ˽
#if Solaris
		int val;
		socklen_t len=sizeof(val);
		if(getsockopt(soc,SOL_SOCKET,SO_ERROR, &val,&len)>=0) {
#elif Linux
			struct sockaddr_in name;
			socklen_t len=sizeof(name);
			if(getpeername(soc,(struct sockaddr*)&name,&len)>=0) {
#endif
				// ˥ǡƤ
			}else{
				// ͥȼ
			}
		}
	}
//ե饰򸵤᤹
	if(fcntl(soc, F_SETFL, flag)<0) perror("fcntl(END) error");
#endif /* 0 */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_close
 * name:         eC0_close
 * global_name:  tSocketClient_eC0_close
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC0_close(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	close( VAR_sd );       /* mikan 顼 */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_reset
 * name:         eC0_reset
 * global_name:  tSocketClient_eC0_reset
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC0_reset(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_send
 * name:         eC0_send
 * global_name:  tSocketClient_eC0_send
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC0_send(CELLIDX idx, const int8_t* buf, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	ssize_t sz;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	while(size>0){
		if((sz=write( VAR_sd, buf, (ssize_t)size )) < 0 ){
			ercd = E_RPC;
			break;
		}
		else{
			size -= sz;
		}
	}

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_flush
 * name:         eC0_flush
 * global_name:  tSocketClient_eC0_flush
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC0_flush(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	/* write ϥХåե󥰤ʤʤΤ flush ʤ */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_receive
 * name:         eC0_receive
 * global_name:  tSocketClient_eC0_receive
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER_UINT
eC0_receive(CELLIDX idx, int8_t* buf, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	ssize_t  sz;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	sz = read( VAR_sd, buf, (ssize_t)size );
#ifdef DEBUG
	{
		int i;
		for( i = 0; i < sz; i++ ){
			printf( "%02X ", (unsigned char)buf[i] );
			if( i % 8 == 7 )
				putchar( '\n' );
		}
		putchar( '\n' );
	}
#endif
	/* mikan ȯɤȲ */
	if( sz < 0 )
		ercd = E_RPC;
	else
		ercd = sz;

	return(ercd);
}

eC0_end_receive(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */

	return(ercd);
}

