#include "tFlg_tecsgen.h"


/* °ޥ */
/*
 * id               ID               ATTR_id         
 */

/* ƤӸؿ */
/*
 */

/* ؿ */
/*
 * entry port: eF
 * signature:  sFlg
 */
/*
 * name:         eF_set_flg
 * global_name:  tFlg_eF_set_flg
 */
ER             eF_set_flg( tFlg_IDX idx, FLGPTN setptn)
{
    ER       ercd_ = E_OK;
    tFlg_CB *p_cellcb;
    if( tFlg_VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
    }else{
        return E_ID;
    }
	ercd_ = set_flg( ATTR_id, setptn );
    return ercd_;
}

/*
 * name:         eF_clr_flg
 * global_name:  tFlg_eF_clr_flg
 */
ER             eF_clr_flg( tFlg_IDX idx, FLGPTN clrptn)
{
    ER       ercd_ = E_OK;
    tFlg_CB *p_cellcb;
    if( tFlg_VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
    }else{
        return E_ID;
    }
	ercd_ = clr_flg( ATTR_id, clrptn );
    return ercd_;
}

/*
 * name:         eF_wai_flg
 * global_name:  tFlg_eF_wai_flg
 */
ER             eF_wai_flg( tFlg_IDX idx, FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn)
{
    ER       ercd_ = E_OK;
    tFlg_CB *p_cellcb;
    if( tFlg_VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
    }else{
        return E_ID;
    }
	ercd_ = wai_flg( ATTR_id, waiptn, wfmode, p_flgptn);
    return ercd_;
}

/*
 * name:         eF_pol_flg
 * global_name:  tFlg_eF_pol_flg
 */
ER             eF_pol_flg( tFlg_IDX idx, FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn)
{
    ER       ercd_ = E_OK;
    tFlg_CB *p_cellcb;
    if( tFlg_VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
    }else{
        return E_ID;
    }
	ercd_ = pol_flg( ATTR_id, waiptn, wfmode, p_flgptn);
    return ercd_;
}

/*
 * name:         eF_twai_flg
 * global_name:  tFlg_eF_twai_flg
 */
ER             eF_twai_flg( tFlg_IDX idx, FLGPTN waiptn, MODE wfmode, FLGPTN* p_flgptn, TMO tmout)
{
    ER       ercd_ = E_OK;
    tFlg_CB *p_cellcb;
    if( tFlg_VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
    }else{
        return E_ID;
    }
	ercd_ = twai_flg( ATTR_id, waiptn, wfmode, p_flgptn, tmout);
    return ercd_;
}

/*
 * entry port: eiF
 * signature:  siFlg
 */
/*
 * name:         eiF_iset_flg
 * global_name:  tFlg_eiF_iset_flg
 */
ER             eiF_iset_flg( tFlg_IDX idx, FLGPTN setptn)
{
    ER       ercd_ = E_OK;
    tFlg_CB *p_cellcb;
    if( tFlg_VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
    }else{
        return E_ID;
    }
	ercd_ = iset_flg( ATTR_id, setptn);
    return ercd_;
}

