#include <t_services.h>
#include "kernel_id.h"

#include "tTask_tecsgen.h"


/* °ޥ */
/*
 * id               ID               ATTR_id         
 * exinf            VP_INT           ATTR_exinf      
 */

/* ƤӸؿ */
/*
 * call port : cMain  signature: sMain
 *   ER             cMain_main( THIS, VP_INT exinf );
 */

/* ؿ */
/*
 * entry port: eT
 * signature:  sTask
 */
/*
 * name:         eT_act_tsk
 * global_name:  tTask_eT_act_tsk
 */
ER             eT_act_tsk( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return act_tsk( ATTR_id );
}

/*
 * name:         eT_can_act
 * global_name:  tTask_eT_can_act
 */
ER_UINT        eT_can_act( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return can_act( ATTR_id );
}

/*
 * name:         eT_ter_tsk
 * global_name:  tTask_eT_ter_tsk
 */
ER             eT_ter_tsk( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return ter_tsk( ATTR_id );
}

/*
 * name:         eT_chg_pri
 * global_name:  tTask_eT_chg_pri
 */
ER             eT_chg_pri( tTask_IDX idx, PRI tskpri)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return chg_pri( ATTR_id, tskpri );
}

/*
 * name:         eT_get_pri
 * global_name:  tTask_eT_get_pri
 */
ER             eT_get_pri( tTask_IDX idx, PRI* p_tskpri)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return get_pri( ATTR_id, p_tskpri );
}

/*
 * name:         eT_wup_tsk
 * global_name:  tTask_eT_wup_tsk
 */
ER             eT_wup_tsk( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return wup_tsk( ATTR_id );
}

/*
 * name:         eT_can_wup
 * global_name:  tTask_eT_can_wup
 */
ER_UINT        eT_can_wup( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return can_wup( ATTR_id );
}

/*
 * name:         eT_rel_wai
 * global_name:  tTask_eT_rel_wai
 */
ER             eT_rel_wai( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return rel_wai( ATTR_id );
}

/*
 * name:         eT_sus_tsk
 * global_name:  tTask_eT_sus_tsk
 */
ER             eT_sus_tsk( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return sus_tsk( ATTR_id );
}

/*
 * name:         eT_rsm_tsk
 * global_name:  tTask_eT_rsm_tsk
 */
ER             eT_rsm_tsk( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return rsm_tsk( ATTR_id );
}

/*
 * name:         eT_frsm_tsk
 * global_name:  tTask_eT_frsm_tsk
 */
ER             eT_frsm_tsk( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return frsm_tsk( ATTR_id );
}

/*
 * name:         eT_ras_tex
 * global_name:  tTask_eT_ras_tex
 */
ER             eT_ras_tex( tTask_IDX idx, TEXPTN rasptn)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return ras_tex( ATTR_id, rasptn );
}

/*
 * entry port: eiT
 * signature:  siTask
 */
/*
 * name:         eiT_iact_tsk
 * global_name:  tTask_eiT_iact_tsk
 */
ER             eiT_iact_tsk( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return iact_tsk( ATTR_id );
}

/*
 * name:         eiT_iwup_tsk
 * global_name:  tTask_eiT_iwup_tsk
 */
ER             eiT_iwup_tsk( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return iwup_tsk( ATTR_id );
}

/*
 * name:         eiT_irel_wai
 * global_name:  tTask_eiT_irel_wai
 */
ER             eiT_irel_wai( tTask_IDX idx)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return irel_wai( ATTR_id );
}

/*
 * name:         eiT_iras_tex
 * global_name:  tTask_eiT_iras_tex
 */
ER             eiT_iras_tex( tTask_IDX idx, TEXPTN rasptn)
{
  struct tag_tTask_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = tTask_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }
  return iras_tex( ATTR_id, rasptn );
}

void tTask_start_task( VP_INT exinf )  /* ΰ exinf ˤ tTask_CB ؤΥݥ󥿤äƤ */
{
  struct tag_tTask_CB *p_cellcb = (struct tag_tTask_CB *)exinf;
  cMain_main( ATTR_exinf );    /* CB ˵Ƥ exinf Ϥ */
};
