#! /usr/bin/env ruby

=begin
tecsmerge ϥƥץ졼ȥե򸵤˺줿륿ץɡʴޥ饤ؿ򵭽Ҥ륿ץ饤إåˤݼ餹ΤǤ롣
륿פ˰ʲβѤä줿б롣
ؿ

% tecsmerge source_dir   dest_dir
% tecsmerge source_files dest_dir

% tecsmerge -p port_name -f old_name:new_name source_file dest_dir
% tecsmerge -p old_name:new_name source_file dest_dir

  p1:p2
  p2:p3
  p3:p1

  f1:f2
  f2:f3
  f3:f1

source_file ̾ _teml.c, _templ.h ǽäƤʤƤϤʤʤ
dest_file  source_file  _templ ̾ǤʤƤϤʤʤ
dest_file ¸ߤʤ硢_templ ̾ǥԡǤ

ʲΥɤ ޤԤõ

0) Ƭ
1) /* #[<PREAMBLE>]#,
2)  * #[</PREAMBLE>]#
3) /* #[<ENTRY_PORT>]#
4)  * #[</ENTRY_PORT>]#
5) /* #[<ENTRY_FUNC>]#
6)  * #[/ENTRY_FUNC>]# */
7) 

嵭Τ 1), 3), 5) 򳫻ϥɤȸƤ֡
ʤäǤΤʤ硢7) Ⳬϥɤ˴ޤࡣ

̾ѹ

a) ̾ѹ

  -p old_port_name:new_port_name

b) ؿ̾ѹ

  -f old_port_name:new_port_name

 old_port_name, new_port_name ϡηǤʤƤϤʤʤ

  ̾ + '_' + ؿ̾


i) إå

  0) ȳϥɤδ

ii) إå

  1) ȳϥɤδ

̾줬ʣ¸ߤ뤳ȤϤʤʣ¸ߤ硢٤ƥե
Ƭ˽Ϥ롣

iii) إå

  3) ȳϥɤδ

إåϡ³μؿμɽΤȲꤵ롣
إåϡפǤϤʤ

iv) ؿ

  5) ȳϥɤδ

=end

require 'optparse'
$n_err = 0
$TMP_APPEND_STR = "___XXX"
$b_show = false

class PortRenamer
  @@port_renamer_list = {}
  @@port_renamer_current = nil

  def initialize( old_port_name, new_port_name )
    @@port_renamer_list[old_port_name] = self
    @@port_renamer_current = self
    @old_port_name = old_port_name
    @new_port_name = new_port_name
    @func_renamer_list = {}
  end

  def self.add_func( old_name, new_name )
    if @@port_renamer_current == nil then
      STDERR.puts( "#{old_name}: specify -p before -f" )
      n_err += 1
    else
      @@port_renamer_current.add_func( old_name, new_name )
    end
  end

  def add_func( old_name, new_name )
    if @func_renamer_list[old_name] then
      STDERR.puts( "#{old_name}: duplicate in port #{@old_port_name}" )
      $n_err += 1
    elsif old_name == new_name then
      STDERR.puts( "#{old_name}: old and new are the same name" )
      $n_err += 1
    end
    @func_renamer_list[old_name] = new_name
  end

  def self.show
    if @@port_renamer_list then
      @@port_renamer_list.each { |pr,pc|
        pc.show
      }
    end
  end

  def show
    print "port: #{@old_port_name}"
    if @new_port_name then
      print " => #{@new_port_name}"
    end
    puts ""

    @func_renamer_list.each { |old,new|
      print "  func: #{old} => #{new}\n"
    }
  end
end


class CDLContents
  #@head::             [string]
  #@preamble_comment:: [string]
  #@preamble_body::    [string]
  #@entry_port::       {ep_name=>CDLEntryPort}
  #@entry_port_array:: [CDLEntryPort]


  DELIMITERS = {
    #    :preamble_pre    => [ Regexp.new( "/\* #\[\<PREAMBLE\>\]" ), [ :HEAD ],                  :PREAMBLE_COMMENT ],
    # state             => [ Regexp,                 previous states                   , regexp ]
    :PREAMBLE_COMMENT   => [ "/* #[<PREAMBLE>]#",              [:HEAD]                  ],
    :PREAMBLE_BODY      => [ " * #[</PREAMBLE>]#",             [:PREAMBLE_COMMENT]      ],
    :ENTRY_COMMENT      => [ "/* #[<ENTRY_PORT>]# PORT_NAME",  [:PREAMBLE_BODY, :ENTRY_FUNC_BODY] ],
    :ENTRY_BODY         => [ " * #[</ENTRY_PORT>]#",           [:ENTRY_COMMENT]                   ],
    :ENTRY_FUNC_COMMENT => [ "/* #[<ENTRY_FUNC>]# FUNC_NAME",  [:ENTRY_BODY, :ENTRY_FUNC_BODY]    ],
    :ENTRY_FUNC_BODY    => [ " * #[/ENTRY_FUNC>]#",            [:ENTRY_FUNC_COMMENT]              ],
  }

  DELIMITERS.each{ |stat, stat_info|
    s = stat_info[0].gsub( /([\*\[\]])/, "\\\\\\1" )   # *, [, ]  \\ 
    s.gsub!( /\s*\w*_NAME/, "\\s*(\\w*)" )              # ..._NAME  (w*) ѹ
    stat_info[2] = Regexp.new( s )
    # p stat_info[2]
  }

  #all_contents:: [string,...]
  def initialize all_contents
    part = []
    line_no = 0
    stat = :HEAD
    arg = nil
    port_name = nil
    func_name = nil

    @entry_port = {}
    @entry_port_array = []

    (all_contents+[nil]).each{ |line|  # nil: EOF
      line_no += 1
      if line 
        part << line
      end

#      p "L: #{line}"
      DELIMITERS.each { |next_stat,stat_info|
#        p "R: #{stat_info[0]}"
        if stat_info[2] =~ line || line == nil then
#          p "D: #{line}: #{stat}"

          if line != nil then
            found = false
            stat_info[1].each{ |prev_stat|
              if stat == prev_stat then
                found = true
              end
            }
            if ! found then
              STDERR << "error #{line_no}: unsuitable previous keyword"
              STDERR << "error #{line_no}:   previous: #{DELIMITERS[stat][0]}"
              STDERR << "error #{line_no}:   current:  #{DELIMITERS[next_stat][0]}"
            end
          end

          case stat   # ξ
          when :HEAD
            @head = part
          when :PREAMBLE_COMMENT
            @preamble_comment = part
          when :PREAMBLE_BODY
            @preamble_body = part
          when :ENTRY_COMMENT
            port_name = arg.to_sym
            @entry_port[ port_name ] = CDLEntryPort.new
            @entry_port_array << @entry_port[ port_name ]
            @entry_port[ port_name ].entry_comment = part
          when :ENTRY_BODY
            @entry_port[ port_name ].entry_body = part
          when :ENTRY_FUNC_COMMENT
            func_name = arg.to_sym
            @entry_port[ port_name ].entry_func_comment[ func_name ] = part
            @entry_port[ port_name ].entry_func_array << func_name
          when :ENTRY_FUNC_BODY
            @entry_port[ port_name ].entry_func_body[ func_name ] = part
          end

          stat = next_stat
          part = []
          arg = $1     # arg ˼äƤ
          # p stat, arg
          break if line == nil
        end
      }
    }
      
  end

  def check template
    # template ˤʤΤå
    @entry_port.each{ |port_name, entry_port|
      temp_entry_port = template.entry_port[port_name]
      if temp_entry_port == nil then
        STDERR << "#{port_name} is deleted port"
        next
      end
      entry_port.entry_func_body.each{ |func_name, func_body|
        if temp_entry_port.entry_func_body[func_name] == nil then
          STDERR << "#{func_name} is deleted function"
        end
      }
    }
  end

  def merge src
    @entry_port.each{ |port_name, entry_port|
      p "merging #{port_name}"
      src_entry_port = src.entry_port[port_name]
      if src_entry_port == nil then
        next
      end
      entry_port.entry_func_body.each{ |func_name, func_body|
        p "merging #{func_name}"
        if src_entry_port.entry_func_body[func_name] == nil then
          print "#{func_name}:  merged"
          next
        end
        print "#{func_name}: remained"
        entry_port.entry_func_comment[func_name] = src_entry_port.entry_func_comment[func_name]
        entry_port.entry_func_body[func_name]    = src_entry_port.entry_func_body[func_name]
      }
    }
  end

  def write file
    file.write @head
    file.write @preamble_comment
    file.write @preamble_body
    @entry_port_array.each{ |port| port.write file }
  end

  attr_accessor :head, :preamble_comment, :preamble_body, :entry_port
end

class CDLEntryPort
  #@entry_comment::      [string]
  #@entry_body::         [string]
  #@entry_func_comment:: {ep_func_name=>string}
  #@entry_func_body::    {ep_func_name=>string}
  #@entry_func_array::   [string]

  def initialize
    @entry_comment = []
    @entry_body = []
    @entry_func_comment = {}
    @entry_func_body = {}
    @entry_func_array = []
  end

  def write file
    file.write @entry_comment
    file.write @entry_body
    @entry_func_array.each{ |fnm|
      file.write @entry_func_comment[fnm]
      file.write @entry_func_body[fnm]
    }
  end

  attr_accessor :entry_comment, :entry_body, :entry_func_comment, :entry_func_body, :entry_func_array
end

def merge( src_file, dst_dir )
  unless src_file =~ /(.*)_templ(.[ch])$/ then
    STDERR.puts( "#{src_file}: not end with _templ.c/h" )
    exit 1
  end

  fname = "#{$1}#{$2}"
  dst_file = "#{dst_dir}/#{File.basename fname}"
  print( "merging #{src_file} to #{dst_file}\n" )
  bkup_file = rename_dst( dst_file )
  if bkup_file then
    # bkup ɹ
    begin
      bkup = open( bkup_file )
      old_contents = bkup.readlines
    ensure
      bkup.close
    end
    old = CDLContents.new( old_contents )

    # template ɹ
    begin
      src = open( src_file )
      new_contents = src.readlines
    ensure
      src.close
    end
    templ = CDLContents.new( new_contents )

    old.check templ
    templ.merge old

    begin
      dst = open( dst_file, "w" )
      templ.write dst
    ensure
      dst.close
    end

  else
    # src_file  dst_file إԡ
    begin
      src = File.open( src_file )
      contents = src.readlines
    rescue
      print "#{src_file}: fail to read"
    ensure
      src.close
    end

    begin
      dst = File.open( dst_file, "w" )
      dst.write( contents )
    rescue
      print "#{dst_file}: fail to write"
    ensure
      dst.close
    end

  end
end

#=== rename_dst
# dst_file ΥХååץե̾ꤷ͡ह
# С͡Υե֤̾
# dst_file ¸ߤʤСʥ͡ϹԤ줺nil ֤
def rename_dst( dst_file )
  begin
    File.stat dst_file
  rescue
    STDERR.puts( "backup not generated for #{dst_file}" )
    # ʤн
    return nil
  end

  i = 0
  found = true
  while found == true
    begin
      i = i + 1
      bkup_file = "#{dst_file}_#{i}"
      File.stat bkup_file
    rescue
      found = false
    end
  end

  begin
    File.rename( dst_file, bkup_file )
    STDERR.puts( "backup generated for #{dst_file} to #{bkup_file}" )
    return bkup_file
  rescue
    STDERR.puts( "fail to rename backup file: #{bkup_file}" )
    exit 1
  end

  return nil
end

ARGV.options {|parser|
  parser.banner = "Usage: tecsgen [options] files"
  parser.on('-p', '--port=old_name:new_name',  "specify entry port name change") { |ps|
    p = ps.split( ':' )
    PortRenamer.new( p[0], p[1] )
  }
  parser.on('-f', '--func=old_name:new_name',  "specify entry function name change") { |fs|
    f = fs.split( ':' )
    PortRenamer.add_func( f[0], f[1] )
  }
  parser.on('-s', '--show_change_set',  "show change set. all substitute") {
    $b_show = true
  }
  parser.version = #{$version}
  parser.release = nil
  parser.parse!
#  if ARGV.empty?
  if ARGV.length < 2 then
    puts parser.help
    exit 1
  end
}

if $b_show then
  PortRenamer.show
end


if $n_err > 0 then
  STDERR.puts( "#{$n_err} errors\n" )
  exit 1
end

src = ARGV[0,ARGV.length-1]
dst = ARGV[-1]

begin
  stat = File.stat dst
rescue
  STDERR.puts( "#{dst}: not found\n" )
  exit 1
ensure
  if stat && ! stat.directory? then
    STDERR.puts( "#{dst}: not directory\n" )
    exit 1
  end
end

src.each { |s|
  begin
    stat = File.stat s
  rescue
    STDERR.puts( "#{s}: not found or cannot access\n" )
    exit 1
  end

  if stat.directory? then
    Dir.foreach(s) {|file|
      if file =~ /_templ.[ch]$/ then
        merge( "#{s}/#{file}", dst )
      end
    }
  elsif stat.file? then
    merge( s, dst )
  end
}
