#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: componentobj.rb 92 2008-05-26 01:43:38Z okuma-top $
#++

# STAGE:
#  B    bnf.y.rb ƽФ
#  P    parse ʳǸƽФbnf.y.rb ľܸƽФ櫓ǤϤʤʸԤ
#  S    P 椫ƽФ뤬ʸ櫓ǤϤʤ̣å
#  G    ʤʳǡʸڤϴǤ롥Դʤ饨顼ǤƤ

# mikan ʲ ruby  mix in Ǽ¸Ǥ뤫⤷ʤ
# Nestable Ѿ硢饹ѿ Nestable ΤΤ̤ͭˤä
# class Nestable
#   @@nest_stack_index = -1
#   @@nest_stack = []
#   @@current_object = nil
# 
#   def self.push
#     @@nest_stack_index += 1
#     @@nest_stack[ @nest_stack_index ] = @@current_object
#     @@current_object = nil
#   end
# 
#   def pop
#     @@current_object = @@nest_stack[ @@nest_stack_index ]
#     @nest_stack_index -= 1
#     if @@nest_stack_index < -1 then
#       raise TooManyRestore
#     end
#   end
# end

#
class Signature
#  @name:: Token
#  @global_name:: name
#  @function_head_list:: NamedList : FuncHead Υ󥹥󥹤
#  @func_name_to_id::  {String}  :  ؿ̾źȤ id 򵭲롥id  signature νи (1Ϥޤ)

  def initialize( name )
    @name = name
    Namespace.new_signature( self )
    if #{Namespace.get_global_name} == "" then
      @global_name = @name
    else
      @global_name = "#{Namespace.get_global_name}_#{@name}"
    end

    @func_name_to_id = {}
  end

  def end_of_parse( function_head_list )
    @function_head_list = function_head_list

    # id դ
    id = 1
    function_head_list.get_items.each{ |f|
      @func_name_to_id[ f.get_name ] = id
      id += 1
    }
  end

  def get_name
    @name
  end

  def get_global_name
    @global_name
  end

  def get_function_head_array
    if @function_head_list then
      return @function_head_list.get_items
    else
      return nil
    end
  end

  #=== ؿ̾ signature  id 
  def get_id_from_func_name func_name
    @func_name_to_id[ func_name ]
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Signature: name: #{@name}"
    (indent+1).times { print "  " }
    puts "function head list:"
    @function_head_list.show_tree( indent + 2 )
  end

end

class Celltype # < Nestable
# @name:: str
# @global_name:: str
# @name_list:: NamedList item: Decl (attribute, var), Port
# @port:: Port[]
# @attribute:: Decl[]
# @var:: Decl[]
# @require:: str[]
# @factory_list::   Factory[]
# @ct_factory_list::    Factory[] :    celltype factory
# @cell_list:: Cell[]
# @singleton:: bool
# @idx_is_id:: bool
# @active:: bool
#
# @n_attribute_ro:: int >= 0   none specified
# @n_attribute_rw:: int >= 0   [rw] specified
# @n_attribute_omit : int >= 0 [omit] specified
# @n_var:: int >= 0
# @n_var_size_is:: int >= 0    [size_is] specified  # mikan count_is
# @n_var_omit:: int >= 0       [omit] specified  # mikan var  omit ͭ
# @n_call_port:: int >= 0
# @n_call_port_array:: int >= 0
# @n_call_port_omitted_in_CB:: int >= 0   ŬǾάƤӸ
# @n_entry_port:: int >= 0
# @n_entry_port_array:: int >= 0
# @n_cell:: int >= 0  ƬǻФ롥̣ʳǤϻԲ
# @id_base:: Integer : cell  ID κǾ(ͤ @id_base + @n_cell)
#
# @b_cp_optimized:: bool : ƤӸŬ»
# @plugin:: PluginObject

  @@nest_stack_index = -1
  @@nest_stack = []
  @@current_object = nil

  def self.push
    @@nest_stack_index += 1
    @@nest_stack[ @@nest_stack_index ] = @@current_object
    @@current_object = nil
  end

  def self.pop
    @@current_object = @@nest_stack[ @@nest_stack_index ]
    @@nest_stack_index -= 1
    if @@nest_stack_index < -1 then
      raise "TooManyRestore"
    end
  end


  def initialize( name )
    @@current_object = self
    @name = name
    if "#{Namespace.get_global_name}" != "" then
      @global_name = "#{Namespace.get_global_name}_#{@name}"
    else
      @global_name = name
    end

    @name_list = NamedList.new( nil, %|symbol in celltype "#{name}"| )
    @port = []
    @attribute = []
    @var = []
    @require = nil
    @factory_list = []
    @ct_factory_list = []
    @cell_list = []
    @singleton = false
    @active = false

    @n_attribute_ro = 0
    @n_attribute_rw = 0
    @n_attribute_omit = 0
    @n_var = 0
    @n_var_omit = 0
    @n_var_size_is = 0
    @n_call_port = 0
    @n_call_port_array = 0
    @n_call_port_omitted_in_CB = 0
    @n_entry_port = 0
    @n_entry_port_array = 0
    @n_cell = 0

    @b_cp_optimized = false

    @plugin = Generator.get_plugin

    if $idx_is_id then
      @idx_is_id = true
    else
      @idx_is_id = false
    end

    Namespace.new_celltype( self )

  end

  def get_name
    @name
  end

  def end_of_parse
    # °ѿΥå
    check_attribute

    # ƤӸ
    generate_allocator_port

    @@current_object = nil
  end

  def self.new_port( port )
    @@current_object.new_port( port )
  end

  def new_port( port )
    @port << port
    @name_list.add_item( port )
    if port.get_port_type == :CALL then
      @n_call_port += 1
      @n_call_port_array += 1 if port.get_array_size != nil
    else
      @n_entry_port += 1
      @n_entry_port_array += 1 if port.get_array_size != nil
    end
    port.set_celltype self
  end

  def get_port_list
    @port
  end

  def self.new_attribute( attribute )
    @@current_object.new_attribute( attribute )
  end

  def new_attribute( attribute )
    @attribute += attribute
    attribute.each { |a|
       @name_list.add_item( a )
       if( a.is_omit? )then
         @n_attribute_omit += 1
       elsif( a.is_rw? )then
         @n_attribute_rw += 1
       else
         @n_attribute_ro += 1
       end
       if a.get_initializer then
         a.type.check_init( a.identifier, a.get_initializer, :ATTRIBUTE )
       end
    }
  end

  #=== celltype  attribute/var Υå
  # STAGE:  S
  #
  # Υ᥽åɤ celltype ΥѡλǸƽФ롥
  def check_attribute
    # attribute  size_is ꤬å
    (@attribute+@var).each{ |a|
      if a.get_size_is then
        if ! a.get_type.kind_of?( PtrType ) then
          # size_is ݥ󥿷ʳ˻ꤵ줿
          Generator.error( "#{a.identifier}: size_is specified for non-pointer type" )
        else

          # Ȥѿ¸ߤ׻ǽʷå
          size = a.get_size_is.eval_const( @name_list )
          init = a.get_initializer
          if init then
            if ! init.instance_of?( Array ) then
              # ҤǤϤʤ
              Generator.error( "#{a.identifier}: unsuitable initializer, need array initializer" )
            elsif size < init.length then
              # size_is ꤵ줿ĿҤǤ¿
              Generator.error( "#{a.identifier}: too many initializer, #{init.length} for #{size}" )
            end
          end
        end
      end
    }
  end

  def get_attribute_list
    @attribute
  end

  #=== ƤӸ
  #    send, receive ΥƽФθƤӸ
  def generate_allocator_port
    @port.each { |port|
      next if port.get_signature == nil                   # signature ̤ʴ˥顼
      fha = port.get_signature.get_function_head_array    # ƤӸޤϼΥ˥δؿ
      next if fha == nil                                  # nil ʤʸˡ顼ͭͤꤵʤä
      fha.each{ |fh|  # fh: FuncHead                      # ؿγƴؿƬ
        fd = fh.get_declarator                            # fd: Decl  (ؿƬDeclarotor)
        if fd.is_function? then                           # fd ؿǤʤСǤ˥顼
          fd.get_type.get_paramlist.get_items.each{ |par| # ٤ƤΥѥ᡼ˤĤ
            case par.get_direction                        #  (in, out, inout, send, receive )
            when :SEND, :RECEIVE
              cp_name = "#{port.get_name}_#{fd.get_name}_#{par.get_name}".to_sym     # ƤӸ̾
              alloc_sig_path = [ par.get_allocator.get_name ]        # mikan Namespace ƤӸΥ˥
              array_size = port.get_array_size            # ƤӸޤϼΥ
              created_port = Port.new( cp_name, alloc_sig_path, :CALL, array_size ) # ƤӸ
              Celltype.new_port( created_port )           # 륿פ˿ƤӸɲ
            end
          }
        end
      }
    }
  end

  def get_name_list
    @name_list
  end

  def self.new_var( var )
    @@current_object.new_var( var )
  end

  def new_var( var )
    @var += var
    var.each { |i|     # i: Decl
      if i.is_omit? then
        @n_var_omit += 1
      else
        @n_var += 1
      end
      @name_list.add_item( i )

      # size_is ꤵ줿? mikan  count_is
      if i.get_size_is then
        @n_var_size_is += 1
      end

      if i.get_initializer then
        i.type.check_init( i.identifier, i.get_initializer, :VAR, @name_list )
      end
    }
  end

  def get_var_list
    @var
  end

  def set_specifier( spec )
    spec.each { |s|
      case s
      when :SINGLETON
        @singleton = true
      when :IDX_IS_ID
        @idx_is_id = true
      when :ACTIVE
        @active = true
      end
    }
  end

  def self.new_require( require )
# mikan new_require
  end

  def self.new_factory( factory )
    @@current_object.new_factory( factory )
  end

  def new_factory( factory )

    if factory.get_f_celltype then
      @ct_factory_list << factory
    else
      @factory_list << factory
    end

    factory.check_arg( self )

  end

  def new_cell( cell )
    # λǤ f_def ꤷƤʤᡢץȥꥹȤ˲ä
    @cell_list << cell
    if @singleton && @cell_list.length > 1 then
      Generator.error( "#{@name}: multiple cell for singleton celltype" )
    end
  end

  #=== 륿פ INIB Ĥ
  # 륿פ INIB ĤɤȽꤹ
  # $rom == false ΤȤ:  INIB ʤ ʤ٤Ƥ CB ֤
  # $rom == true ΤȤINIB ֤ΤĤǤ¸ߤ INIB 
  #   INIB ֤Τ
  #     attribute (omit ΤΤϽͤǤ rw ΤΤϤʤ)
  #     size_is ȼ var
  #     ƤӸʤŬפȤʤΤϽ
  def has_INIB?
    return $rom && (@n_attribute_ro > 0 || @n_var_size_is > 0 || ( @n_call_port - @n_call_port_omitted_in_CB ) > 0)
#    return $rom && (@n_attribute_ro > 0 || ( @n_call_port - @n_call_port_omitted_in_CB ) > 0)
  end

  #=== 륿פ CB Ĥ
  # $rom == true ΤȤΤΤ֤롥ΰĤǤ¸ߤ CB 
  #   size_is ꤵƤʤ var
  #   rw ꤵ줿 attribute (ͤǤ¸ߤʤ)
  # $rom == false ΤȤΤΤ֤롥ΰĤǤ¸ߤ CB 
  #   attribute
  #   var
  #   ƤӸʤŬפȤʤΤϽ
  def has_CB?
    if $rom then
      return @n_attribute_rw > 0 || (@n_var-@n_var_size_is) > 0
      # return @n_attribute_rw > 0 || @n_var > 0
    else
      return @n_attribute_rw > 0 || @n_attribute_ro > 0 || @n_var > 0 || (@n_call_port-@n_call_port_omitted_in_CB) > 0
    end
  end

  def find( name )
    @name_list.get_item( name )
  end


  def get_global_name
    @global_name
  end

  def is_singleton?
    @singleton
  end

  def is_active?
    @active
  end

  def get_id_base
    @id_base
  end

  def get_plugin
    @plugin
  end

  #=== ɬפ뤫Ƚ
  # θĿ 0 ʤ饻륿ץɤ
  def need_generate?
    @n_cell > 0
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Celltype: name: #{@name} global_name: #{@global_name}"  
    (indent+1).times { print "  " }
    puts "active: #{@active}, singleton: #{@singleton}, idx_is_id: #{@idx_is_id}"
    (indent+1).times { print "  " }
    puts "port:"
    @port.each { |i| i.show_tree( indent + 2 ) }
    (indent+1).times { print "  " }
    puts "attribute:"
    @attribute.each { |i| i.show_tree( indent + 2 ) }
    (indent+1).times { print "  " }
    puts "var:"
    @var.each { |i| i.show_tree( indent + 2 ) }
#    (indent+1).times { print "  " }
#    puts "require:"   mikan
#    @require.each { |i| i.show_tree( indent + 2 ) }
    (indent+1).times { print "  " }
    puts "factory:"
    @factory_list.each { |i| i.show_tree( indent + 2 ) }
  end
end

class Cell # < Nestable
# @name:: str : composite celltype ¦Υ󥹥󥹤ǤϳΥ
# @global_name:: str : C ǻȤ̾namespace ޤ
# @local_name:: str : cell celltype name { ... }  name
# @celltype:: Celltype | CompositeCelltype
# @join_list:: NamedList
# @in_composite:: bool : true if in composite celltype
# @f_def:: definition flag (false if only prototype )
# @f_ref:: refercenced from others
# @compositecelltypejoin_list:: NamedList : item= CompositeCelltypeJoin ( if @in_composite )
# @f_clone:: bool : true if cloned (instantiate of composite consist cell)
# @my_clone:: Cell : Composite cell  in_composite = true ξΤͭľ clone 
# @prototypes:: Cell[] : prototype  : change_item Ρ¾黲ȤƤ뤫⤷ʤΡ
# @cell_list:: Cell[local_name] : Composite cell  clone Υꥹ cell_list
# @region:: Region (°region)
# @alloc_list::  [ [ ep_name, func_name, param_name, expr ], ... ]
# @id:: Integer : ľ  (ץȥξ -1 Τޤ)

  @@nest_stack_index = -1
  @@nest_stack = []
  @@current_object = nil

  def self.push
    @@nest_stack_index += 1
    @@nest_stack[ @@nest_stack_index ] = @@current_object
    @@current_object = nil
  end

  def self.pop
    @@current_object = @@nest_stack[ @@nest_stack_index ]
    @@nest_stack_index -= 1
    if @@nest_stack_index < -1 then
      raise "TooManyRestore"
    end
  end


  # composite  clone 줿Ρʻ¹ޤǴޤ
  # Join.change_rhs_port ˤ CompoisteCelltype  Join ηѹݤ˻
  @@cloned_cell_list = {}
  ### mikan BUG @@cloned_cell_list  composite γؤȤ˵ƤʤᡢƱ̾˸ȡޤưʤ
  # change_rhs_port μϡʲ꤯ɤȤ򤹤ɬפϤʤäդ˸륻̾ˤϡcomposite Υ̾ˤĤʤǤ褫ä


  def initialize( ct_path, in_composite = false )

    @region = Region.get_current

    # celltype ¸ߤå
    object = Namespace.find( ct_path )
    if object == nil then
      # mikan celltype ̾Դ "::ct1ct2" ˤʤ
      Generator.error( "'#{ct_path}' celltype not found" )
    elsif ! object.instance_of?( Celltype ) && ! object.instance_of?( CompositeCelltype ) then
      # mikan celltype ̾Դ
      Generator.error( "'#{ct_path}' not celltype" )
    else
      @celltype = object
      if in_composite == false && @celltype.instance_of?( Celltype ) then
        @celltype.new_cell self
      end
    end

    @in_composite = in_composite
    if @in_composite then
      @compositecelltypejoin_list = NamedList.new( nil, "in cell '#{@name}'" )
    end

    @prototypes = []
    @@current_object = self
    @f_cloned = false
    @alloc_list = []
    @id = -1

  end

  def self.set_name( name )
    @@current_object.set_name( name )
  end

  def set_name( name )
    @name = name
    @local_name = name
    if "#{Namespace.get_global_name}" != "" then
      @global_name = "#{Namespace.get_global_name}_#{name}"
    else
      @global_name = name
    end

#   λǤϥץȥפʬʤʻȤΤϿ
    if @in_composite then
      CompositeCelltype.new_cell( self )
    else
      Namespace.new_cell( self )
    end

    @join_list = NamedList.new( nil, "in cell '#{@name}'" )

    # debug
    # print "Cell new_cell: #{@global_name} #{@in_composite} #{self}\n"
  end

  def self.new_join( join )
    @@current_object.new_join( join )
  end

  #===  å
  # STAGE:   P
  #
  #join::  Join : 
  def new_join( join )

    # composite οʸˡб
    # composite Υǡattribute Ǥ
    # cell  attr_ext = composite.attr; ʸ
    if @in_composite then
      if @celltype then
        if @celltype.find(join.get_name).instance_of?( Decl ) then
          rhs = join.get_rhs
          if rhs.instance_of? Expression then
            ele = rhs.get_elements
            if( ele[0]==:IDENTIFIER )then    #  attr = attr_ext ʱñˤ
              if( CompositeCelltype.has_attribute?(ele[1].to_s ) )then
                ident = ele[1].to_s   # դ attribute
              else
                # դ attribute ˤʤΤǤСΤϤ
                # ϲϤ (cell  join ˤ)
                ident = nil
              end
            else
              if join.get_rhs.eval_const(nil) == nil then   # ǤϤʤ
                # դñΥܥǤʤ硢ϰʤ
                Generator.error( "rhs expression is not supported. Only attribute is permitted on current version." )
                return
              else
                # ϲϤ (cell  join ˤ)
                ident = nil
              end
            end

            if ident then
              # attr = attr; Τ褦ʻȤϥ顼 (a = composite.a Ȥɬפ)
              if @celltype.find( ident ) then
                Generator.error( "#{ident} : cannot refer to #{@celltype.get_name}'s attribute here. Use 'composite.#{ident}' to refer to composite celltype's" )
              end
            end
          elsif rhs.instance_of? Array then
            if rhs[0] == :COMPOSITE then   # դ composite.attr η
              ident = rhs[1].to_s
            else
              ident = nil    # դ { 10, -10 } η
            end
          else
            ident = nil      # դ C_EXP η
          end

          # ident Ĥäʱդñ ident
          if ident then
            # composite εʸˡιʸϤ볰 attr_ext = Cell.attr; ʸνϤ
            #                        export_name, internal_cell_name, internal_cell_elem_name
            decl = CompositeCelltype.new_join( ident, @name, join.get_name, :ATTRIBUTE )
            if ! decl.instance_of? Decl then
              return
            end
            ini = decl.get_initializer
            if ini == nil then
              return
            end
            # ʲεʸˡϤ
            # ʸˡǤ cell ˽ͤͿ뤳Ȥǡcomposite °νͤꤹ뤳ȤǤ
            # attribute ǻꤵ줿ͤ cell °Ȥƽ
            join.change_rhs( ini )
          else
            # ident ʤ
          end
        else
          # celltype °Ȥơ join ̾ʤ
          # ʲ join.set_definition ǥ顼Ȥʤ
        end
      else
        return    # celltype ʤǤ˥顼
      end
    elsif join.get_rhs.instance_of? Array then
      rhs = join.get_rhs
      if rhs[0] == :COMPOSITE then
        # composite ǤʤΤ attr = composite.attr Ȥ줿
        Generator.error( "composite : cannot specify out of composite celltype definition" )
        return
      end
    end

    # ʲ composite ʸˡѹ餢

    # ˺դƱ̾ν¸ߤ뤫
    j = @join_list.get_item( join.get_name )
    if j.instance_of? Join then    # mikan Ǥ j  Join or Nil ʳϡʤϤ

      # join å
      join.set_definition( @celltype.find(join.get_name) )

      # debug
      # print "add_array_member: #{@name} port: #{j.get_port_name} rhs: #{j.get_rhs}, #{join.get_port_name} #{join.get_rhs}\n"
      # ƤӸʤǤȲꤷơǤɲ
      j.add_array_member join

    else
      # join
      @join_list.add_item( join )
      if @celltype  # ° celltype ¸ߤƤ뤫
        join.set_definition( @celltype.find(join.get_name) )
      end
    end

  end

  def self.external_join( internal_cell_elem_name, export_name, b_composite )
    @@current_object.external_join( internal_cell_elem_name, export_name, b_composite )
  end

  #=== cell ˵ҤƤӸγ
  # internal_cell_elem_name:: string : ƤӸ̾
  # export_name:: string: composite γ˸ƤӸ̾
  #  ƤӸ礹롥
  #  Υ᥽åɤϡcomposite  cell ǤƤФʤ
  def external_join( internal_cell_elem_name, export_name, b_composite )

    # cCall => composite.cCall; ǤϤʤ
    if( b_composite == false )then
      # cCall => cCall; Τ褦ʾ
      if @celltype.find( export_name ) then
        Generator.error( "#{export_name} : cannot refer to #{@celltype.get_name}'s here. Use 'composite.#{export_name}' to refer to composite celltype's" )
      end
    end
    # composite εʸˡˤ롢cell  cCall = Cell.cCall; ιʸϤ
    CompositeCelltype.new_join( export_name, @name,  internal_cell_elem_name, :CALL )
  end

  def self.end_of_parse f_def
    cell = @@current_object
    cell.set_specifier_list( Generator.get_statement_specifier )

    @@current_object.set_f_def f_def
    @@current_object = nil
    return cell
  end

  #===  (false)(true)
  #    Υ᥽åɤϹʸκǸ˸ƽФ
  #f_def::     bool     false if declaration, true if definition
  def set_f_def f_def
    @f_def = f_def              # false: prototype declaration

    if @f_def then

      # ⤦Ͽʤ
      # set_name  new_cell  f_def = false ʤץȥפȤߤʤƤޤ
      # ʸ¿ѹ뤳ȤǤǽǤϤΤ褦ˤ
      if @in_composite then
        CompositeCelltype.new_cell( self )
      else
        Namespace.new_cell( self )
      end

      if ! @in_composite then
        check_join
        if @celltype.instance_of?( CompositeCelltype ) then

          # Ÿ줿Υꥹ
          @@cloned_cell_list = {}

          # composite celltype  cell Ÿ
          @cell_list = @celltype.expand( @name, @global_name, @join_list )

          # ƤӸαդΥ clone Τѹ
          self.change_rhs_port

        end
#     else
#       check_join  compositecelltype ˸ƤФ
      end

    end

  end

  def set_f_ref
    @f_ref = true
  end

  #=== Ҥ
  # STAGE:  B
  #
  #    bnf.y.rb  statement_specifiler_list
  #spec_list::      [ :ALLOCATOR, [ [ ep_name, subscript, func_name, param_name, expr ], ... ] ]
  #                     s[0]      s[1]   a[0]     a[1]       a[2]        a[3]     a[4]
  #    a[1]  subscript ϤΥ᥽åɤ Expression  Integer ɾ
  def set_specifier_list( spec_list )
    return if spec_list == nil  # ʤв⤷ʤ

    spec_list.each{ |s|
      case s[0]             # statement_specifier
      when :ALLOCATOR       # [allocator(ePort.func.param=allocCell.eA,ePort.func2.param=allocCell.eA)]
        s[1].each { |a|     # alloc_list : allocator  ',' Ƕڤ줿ʬ
          cp_name = "#{a[0]}_#{a[2]}_#{a[3]}".to_sym    # ƤӸ̾'=' κդ '.' Ѥ '_' Ϣ
          # p "#{a[0]} #{a[2]} #{a[3]} #{cp_name}"
          if a[1] then
            subscript = a[1].eval_const nil
            a[1] = subscript
          else
            subscript = nil
          end
          Join.new( cp_name, subscript, a[4] )
          @alloc_list << a 
        }
      else
        raise "unknown specifier for cell: #{s[0]}"
      end
    }
  end

  def get_allocator_list
    @alloc_list
  end

  def add_compositecelltypejoin join
    @compositecelltypejoin_list.add_item join
  end

  def add_prototype proto
    @prototypes << proto
  end

  #===  cell  composite 륿פΥѤ clone 
  #name::        string : cell ̾  (cell tComposite cell1 Ǥ cell1)
  #global_name:: string : cell  global_name 
  #join_array::  Join[] : composite  cell  join ǡ cell б
  #Υ᥽åɤ CompositeCelltype  expand ƽФ
  def clone_for_composite( name, global_name, join_array )

    # debug
    # print "cell.clone_for_composite : cloning: #{@name} #{global_name}\n"

    @my_clone = self.clone
    @@cloned_cell_list[ self ] = @my_clone

    # clone ˻̾Ĵ
    @my_clone.set_cloned( name, global_name, join_array )
    Namespace.new_cell( @my_clone )

    # @celltype == nil ϰ˥륿̤顼
    if @celltype != nil && ! @celltype.instance_of?( CompositeCelltype ) then

      # celltype ϿʥоݤȤʤ
      @celltype.new_cell( @my_clone )
    end

    return @my_clone
  end

  #=== clone 줿˻̾Ĵ
  #name::        string : cell ̾  (cell tComposite cell1 Ǥ cell1)
  #global_name:: string : cell  global_name 
  #join_array::  Join[] : composite  cell  join ǡ cell б
  #  Υ᥽åɤϤ clone_for_composite ƽФ졢clone 줿
  def set_cloned( name, global_name, join_array )

    # debug
    # print "cell.set_cloned : global_name: #{global_name}  name: #{name}  @name: #{@name}\n"

    @global_name = "#{global_name}_#{@name}"
    @name = "#{name}_#{@name}"

    @in_composite = false
    @f_cloned = true

    # ΥΥץȥפˤĤ cloned_cell ȤơΥ
    @prototypes.each { |pc|
      @@cloned_cell_list[ pc ] = self
    }

    # join_list : NamedList  clone 
    @join_list = @join_list.clone_for_composite
    join_array.each { |j|
      @join_list.change_item j
    }

    # clone 褦Ȥ륻뤬 composit 륿ס
    if @celltype.instance_of?( CompositeCelltype ) then
      # composite cell ƵŪŸ
      @cell_list = @celltype.expand( @name, @global_name, @join_list )
    end

  end

  #===  clone 줿 cell  join_list αդѹ
  #  ƤӸαդ cell ¾ clone 줿 cell ִ
  def change_rhs_port

    @join_list.get_items.each { |j|
      j.change_rhs_port( @@cloned_cell_list, @celltype )
    }

    # debug
    # print "Cell change_rhs_port: global_name: #{@global_name}\n"

    if @celltype.instance_of?( CompositeCelltype ) then

      # ҤΥˤĤƤѹ
      @cell_list.each{ |name,c|
        c.change_rhs_port
      }
    end
  end

  def get_f_def
    @f_def
  end

  def get_f_ref
    return true if @f_ref

    @prototypes.each { |pc|
       return true if pc.get_f_ref
    }
    return false
  end

  def get_name
    @name
  end

  def get_local_name
    @local_name
  end

  def get_global_name
    @global_name
  end

  def get_region
    @region
  end

  # composite cell  port б cell  port ̾ʥ󥯻ɬפ̾
  def get_real_global_name port_name
    if @celltype.instance_of?( CompositeCelltype ) then

      # debug
      # print "get_real_global_name: cell name: #{@name} #{@local_name} #{@global_name} #{port_name}\n"
      # @cell_list.each{ |n,c|
      #   print "   name: #{n}"
      #   print " get_name: #{c.get_name} local_name: #{c.get_local_name}"  if c
      #   print "\n"
      # }

      cj = @celltype.find_export( port_name )

      # debug
      # print " composite join name: #{cj.get_name}  cell: #{cj.get_cell_name}  cell elem: #{cj.get_cell_elem_name}\n"

      name = @cell_list[ "#{cj.get_cell_name}" ].get_real_global_name( cj.get_cell_elem_name )
      return name

    else
      # debug
      # print "  get_real_global_name: cell name: #{@global_name}\n"

      return @global_name
    end
  end

  #=== μ port_name ФºݤΥ̾̾ '_' Ϣ
  #    namespace ̾ + '_' + ̾ + '_' + ̾   ʤΥ뤬 composite ʤŸΥ̾̾
  def get_real_global_port_name port_name

    # composite 
    if @celltype.instance_of?( CompositeCelltype ) then

      # debug
      # print "get_real_global_port_name: cell name: #{@name} #{@local_name} #{@global_name} #{port_name}\n"
      # @cell_list.each{ |n,c|
      #   print "   name: #{n}"
      #   print " get_name: #{c.get_name} local_name: #{c.get_local_name}"  if c
      #   print "\n"
      # }

      # 륿 port_name  CompositeCelltypeJoin õʥʳǤɬĤ
      cj = @celltype.find_export( port_name )

      # debug
      # print "   composite join name: #{cj.get_name}  cell: #{cj.get_cell_name}  cell elem: #{cj.get_cell_elem_name}\n"

      # composite ΥФƵŪ get_real_global_port_name Ŭ
      name = @cell_list[ "#{cj.get_cell_name}" ].get_real_global_port_name( cj.get_cell_elem_name )
      return name

    else
      # debug
      # print "get_real_global_port_name:  cell name: #{@global_name}\n"

      return "#{@global_name}_#{port_name}"
    end
  end

  #=== PORT (celltype ) 
  def get_real_port( port_name )

    # composite 
    if @celltype.instance_of?( CompositeCelltype ) then

      # 륿 port_name  CompositeCelltypeJoin õʥʳǤɬĤ
      cj = @celltype.find_export( port_name )

      # composite ΥФƵŪ get_real_port Ŭ
      port = @cell_list[ "#{cj.get_cell_name}" ].get_real_port( cj.get_cell_elem_name )
      return port
    else

      return @celltype.find( port_name )
    end
  end

  #=== cell 
  #    composite ǤʤмʬȤ֤
  def get_real_cell( port_name )

    # composite 
    if @celltype.instance_of?( CompositeCelltype ) then

      # 륿 port_name  CompositeCelltypeJoin õʥʳǤɬĤ
      cj = @celltype.find_export( port_name )

      # composite ΥФƵŪ get_real_port Ŭ
      cell = @cell_list[ "#{cj.get_cell_name}" ].get_real_cell( cj.get_cell_elem_name )
      return cell
    else

      return self
    end
  end

  def get_internal_port_name port_name
    if @celltype.instance_of?( CompositeCelltype ) then
      cj = @celltype.find_export( port_name )
#      return "#{@name}_#{cj.get_cell.get_internal_port_name cj.get_cell_elem_name}"
      return cj.get_cell.get_internal_port_name( cj.get_cell_elem_name )
    else

      # debug
      # print "  get_global_port_name: cell port: #{@global_name}_#{port_name}\n"

      return "#{@global_name}_#{port_name}"
    end
  end

  def get_celltype
    @celltype
  end

  def get_join_list
    @join_list
  end

  def set_id id
    @id = id
    @prototypes.each{ |pc|
      pc.set_id id
    }
  end

  def get_id
    @id
  end

  #===  (Join)Υå
  #     Join ϸƤӸηޤ attribute ν
  def check_join

    # celltype ʤХåʤʴ˥顼
    return if @celltype == nil

    # debug
    # if @compositecelltypejoin_list
    #   p "check_join"
    #   @compositecelltypejoin_list.get_items.each { |cj| p "#{cj.get_name} #{cj.get_name.object_id}" }
    # end

    # celltype ƤƤΥݡȤˤĤ
    @celltype.get_port_list.each { |p|

      # ƤӸǤʤСåʤ
      next if p.get_port_type != :CALL

      # debug
      # print "check_join: #{p.get_name}\n"

      # ꥹȤ椫ƤӸ̾˰פΤ
      j = @join_list.get_item( p.get_name )

      if j == nil then
        # ̤θƤӸ

        # composite celltype ξ硢composite celltype  export ƤӸ˷礵Ƥ뤫õ
        found = false
        if @in_composite then
          # composite celltype  export Τ٤Ƥõ
          # export Ταͤõ get_item Ǥϥ
          @compositecelltypejoin_list.get_items.each{ |cj|
            # ƤӸ̾ composite  export ̾ϰפ뤫
            if p.get_name == cj.get_cell_elem_name then
              found = true
            end
          }
        end
        if ! found then
          Generator.error( "call port '#{p.get_name}' not initialized in cell '#{@name}'\nIf port has send/receive parameter, this error might be caused by no allocator initialize in entry port side cell." )
        end
      elsif p.get_array_size.kind_of? Integer then  # ̾ Integer ǤϤʤ Fixnum 饹
        # źƤӸξ硢٤ƤźǤƤ뤫å

        am = j.get_array_member 
        if( am )then
          # join 

          # ƤӸǤ礭
          length = p.get_array_size

          # 礭ƤӸȷǰפ뤫
          if am.length != length then
            Generator.error( "#{p.get_name}: array initializer too many or few, #{am.length} for #{length}" )
          end

          # Ǥȴʤå
          if am.length < length then  # ʤ˥顼ǤΤϰϤǥå
            length = am.length
          end
          i = 0
          while( i < length )
            if am[i] == nil then
              Generator.error( "#{p.get_name}[#{i}]: not initialized" )
            end
            i += 1
          end

        # else
        # join ǤС˥顼
        end

      end
    }

    # ݥ󥿷ǽΥå
    (@celltype.get_attribute_list+@celltype.get_var_list).each { |a|
      if a.get_size_is then

        if( ! a.get_type.kind_of?( PtrType ) ) then
          Generator.error( "#{a.get_name}: size_is specified for non-pointer type" )
        else
          size = a.get_size_is.eval_const( @join_list, @celltype.get_name_list )
          a.get_type.set_scs( a.get_size_is, nil, nil )
          if( size == nil )then
            # mikan ¿ʬǤΥ顼ȯסeval_const ѿ¸ߤʤŬڤʤɤΥ顼ˤʤϤ
            Generator.error( "#{a.get_name}: size_is arg not constant" )
          else
            j = @join_list.get_item( a.identifier )
            if j then
              ini = j.get_rhs
              if ini then
                if ! ini.instance_of?( Array ) then
                  Generator.error( "unsuitable initializer, need array initializer" )
                elsif size < ini.length then
                  Generator.error( "too many initializer for array, #{ini.length} for #{size}" )
                else
                  # a.get_type.set_scs( a.get_size_is, nil, nil )
                end
              end
            end
          end
        end
      end
    }

#  mikan ¿ʬ
#    @celltype.get_attribute_list.each { |a|
#      if @join_list.get_item( a.get_name ) == nil &&
#                         a.get_initializer == nil then
#        if @in_composite == false || @compositecelltypejoin_list.get_item( a.get_name ) == nil then
#          Generator.error( "attribute '#{a.get_name}' not initialized in cell '#{@name}'" )
#        end
#      end
#   
#    }
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Cell: name: #{@name} in_composite: #{@in_composite} def: #{@f_def} cloned: #{@f_cloned}"
    (indent+1).times { print "  " }
    puts "id: #{@id}  global_name: #{@global_name}  region: #{@region.get_name}"
    if @celltype then
      (indent+1).times { print "  " }
      puts "celltype: #{@celltype.get_name}"
    end
    @join_list.show_tree( indent + 1 )
    if @cell_list then   #  @cell_list  nil ʤΤ Bug
      (indent+1).times { print "  " }
      puts "cloned cell list:"
      @cell_list.each { |n,c|
        (indent+2).times { print "  " }
        puts "inner cell : #{n} = #{c.get_name}"
      }
    end
  end

end

class CompositeCelltype # < Nestable
# @name:: str
# @global_name:: str
# @cell_list:: NamedList   Cell
# @export_name_list:: NamedList : CompositeCelltypeJoin
# @port_list:: CompositeCelltypeJoin[]
# @attr_list:: CompositeCelltypeJoin[]
# @b_singleton:: bool
# @b_active:: bool
# @real_singleton:: bool
# @real_active:: bool
# @name_list:: NamedList item: Decl (attribute), Port ݡ

  @@nest_stack_index = -1
  @@nest_stack = []
  @@current_object = nil

  def self.push
    @@nest_stack_index += 1
    @@nest_stack[ @@nest_stack_index ] = @@current_object
    @@current_object = nil
  end

  def self.pop
    @@current_object = @@nest_stack[ @@nest_stack_index ]
    @@nest_stack_index -= 1
    if @@nest_stack_index < -1 then
      raise "TooManyRestore"
    end
  end


  def initialize( name )
    @name = name
    @cell_list = NamedList.new( nil, "in composite celltype #{name}" )
    @export_name_list = NamedList.new( nil, "export in composite celltype #{name}" )
    @name_list = NamedList.new( nil, "in composite celltype #{name}" )
    @@current_object = self

    @b_singleton = false
    @real_singleton = nil
    @b_active = false
    @real_active = nil

    if #{Namespace.get_global_name} == "" then
      @global_name = @name
    else
      @global_name = "#{Namespace.get_global_name}_#{@name}"
    end

    Namespace.new_compositecelltype( self )

    @port_list = []
    @attr_list = []
  end

  def self.end_of_parse
    @@current_object.end_of_parse
    @@current_object = nil
  end

  def end_of_parse
    if @b_singleton && @real_singleton == nil then
      Generator.warning( "#{@name} : specified singleton but has no singleton in this celltype" )
    elsif ! @b_singleton && @real_singleton != nil then
      if ! @b_singleton then
        Generator.error( "#{@name} must be singleton. inner cell '#{@real_singleton.get_name}' is singleton" )
      end
    end
    if @b_active && @real_active == nil then
      Generator.error( "#{@name} : specified active but has no active in this celltype" )
    elsif ! @b_active && @real_active != nil then
      Generator.error( "#{@name} must be active. inner cell '#{@real_active.get_name}' is active" )
    end

    @cell_list.get_items.each{ |c|
      c.check_join
    }
    @port_list.each{ |p|
      p.check_dup_init
    }

    # ٤ƤΥݡбƤӸ°¸ߤ뤫å
    @name_list.get_items.each{ |n|
      if( @export_name_list.get_item( n.get_name ) == nil )then
        Generator.error( "#{n.get_name} : cannot export, nothing designated" )
      end
    }


  end

 ### cell
  def self.new_cell( cell )
    @@current_object.new_cell( cell )

  end

  def new_cell( cell )
    cell_prev = @cell_list.get_item( cell.get_name )
    if cell_prev == nil then
      @cell_list.add_item( cell )
    else
      if cell.get_celltype != cell_prev.get_celltype then
        Generator.error( "#{cell.get_name}: celltype mismatch with previous one" )
      else
        # ϴ˺ѤǤ뤫
        if cell_prev.get_f_def == true then
          # new_cell  2 ٤Ӥ
          if ( ! cell_prev.equal? cell ) && cell.get_f_def == true then
            Generator.error( "#{cell.get_name}: duplicate" )
          #else
          # θ˥ץȥʤ줿ʻȤ뤳ȤϤʤ̵
          end
        else
          # ץȥʤС򴹡ʰΤΤ񤭡
          cell.add_prototype cell_prev
          @cell_list.change_item( cell )
        end
        if cell.get_celltype then    # nil ʤСǤ˥륿פʤ顼
          if cell.get_celltype.is_singleton? then
            @real_singleton = cell
          end
          if cell.get_celltype.is_active? then
            @real_active = cell
          end
        end
      end
    end
  end

 ### join
  def self.new_join( export_name, internal_cell_name,
			 internal_cell_elem_name, type )
    @@current_object.new_join( export_name, internal_cell_name,
					 internal_cell_elem_name, type )
    
  end

  #=== CompositeCelltypeJoin 
  #export_name:: string : ˸̾
  #internal_cell_name:: string : ̾
  #internal_cell_elem_name:: string : ̾ʸƤӸ̾̾°̾Τ줫
  #type::  :CALL, :ENTRY, :ATTRIBUTE Τ줫ʹʸǤȤƤ٤Ρ
  #RETURN:: Decl | Port : ݡ
  # new_join 
  #   cCall => composite.cCall; attr = composite.attr; composite.eEnt => cell2.eEnt;
  # ιʸǤνиФƸƤӽФ
  def new_join( export_name, internal_cell_name,
		 internal_cell_elem_name, type )

    cell = @cell_list.get_item( internal_cell_name )
    if cell == nil then
      Generator.error( "#{internal_cell_name} not found in #{@name}" )
      return
    end

    celltype = cell.get_celltype
    return if celltype == nil	# celltype == nil ʤ餹Ǥ˥顼

    # Υ륿פбǤõ
    # Υ᥽åɤϡʸ塢ƤӸ°ҤǤս꤫ƽФ
    # ʸθƽФ֡ʵҰ֡ˤȡǤбΤå
    obj = celltype.find( internal_cell_elem_name )
    if obj.instance_of?( Decl ) then
      if obj.get_kind == :VAR then
        Generator.error( "'#{internal_cell_elem_name}' : cannot export var" )
        return
      elsif type != :ATTRIBUTE then
        Generator.error( "'#{export_name}' : exporting attribute. write in cell or use '=' to export attribute" )
        # return Υ顼򤱤뤿˽³ԤդäƤߤ
      end
    elsif obj.instance_of?( Port ) then
      if obj.get_port_type != type then
        Generator.error( "'#{export_name}' : port type mismatch. #{type} type is allowed here." )
        # return Υ顼򤱤뤿˽³ԤդäƤߤ
      end
    end

    # ݡȰפ뤫ɤå
    obj2 = @name_list.get_item( export_name )
    if( obj2 == nil )then
      Generator.error( "#{export_name} has no export definition" )
    elsif obj2.instance_of?( Decl ) then
      if( ! obj.instance_of? Decl )then
        Generator.error( "#{export_name} is port but previously defined as an attribute" )
      elsif ! obj.get_type.equal? obj2.get_type then
        Generator.error( "#{export_name} : type '#{obj.get_type.get_type_str}#{obj.get_type.get_type_str_post}' mismatch with previous definition'#{obj2.get_type.get_type_str}#{obj2.get_type.get_type_str_post}'" )
      end
    elsif obj2.instance_of?( Port ) then
      if( obj.instance_of? Port )then
        if( obj.get_port_type != obj2.get_port_type )then
          Generator.error( "#{export_name} : port type #{obj.get_port_type} mismatch with previous definition #{obj2.get_port_type}" )
        elsif obj.get_signature != obj2.get_signature then
          Generator.error( "#{export_name} : signature '#{obj.get_signature.get_name}' mismatch with previous definition '#{obj2.get_signature.get_name}'" )
        elsif obj.get_array_size != obj2.get_array_size then
          Generator.error( "#{export_name} : array size mismatch with previous definition" )
        end
      else
        Generator.error( "#{export_name} is an attribute but previously defined as a port" )
      end
    end

    join = CompositeCelltypeJoin.new( export_name, internal_cell_name,
				 internal_cell_elem_name, cell, obj )
    cell.add_compositecelltypejoin join

    # debug
    # print "compositecelltype join: add #{cell.get_name} #{export_name} = #{internal_cell_name}.#{internal_cell_elem_name}\n"

    if obj.instance_of?( Decl ) then
      @attr_list << join
    else
      @port_list << join
    end

    @export_name_list.add_item( join )

    # ݡ֤
    return obj2
  end

  def self.has_attribute? attr
    @@current_object.has_attribute? attr
  end

  def has_attribute? attr
    @name_list.get_item( attr ) != nil
  end

  def self.new_port port
    @@current_object.new_port port
  end

  #=== new_port
  def new_port port
    @name_list.add_item port
  end

  def self.new_attribute attr
    @@current_object.new_attribute attr
  end

  #=== new_attribute
  def new_attribute( attribute )
    attribute.each { |a|
       @name_list.add_item( a )
       if a.get_initializer then
         a.type.check_init( a.identifier, a.get_initializer, :ATTRIBUTE )
       end
    }
  end

  # false : if not in celltype definition, nil : if not found in celltype
  def self.find( name )
    if @@current_object == nil then
      return false
    end
    @@current_object.find name
  end

  def find name
    cell = @cell_list.get_item( name )
    return cell if cell

# p "#{name}, #{@name_list.get_item( name )}"
    return @name_list.get_item( name )

    # 
#    cj = @export_name_list.get_item( name )
#p "#{name}, #{cj.get_port_decl}"
#    if cj then
#      return cj.get_port_decl
#    else
#      return nil
#    end
  end

  def find_export name
    return @export_name_list.get_item( name )
  end

  #=== composite celltype  cell Ÿ
  #name:: string: Composite cell ̾
  #global_name:: string: Composite cell  global name (C ̾)
  #join_list:: NamedList : Composite cell Ф Join  NamedList
  def expand( name, global_name, join_list )

    # debug
    # print "expand composite: #{@name} name: #{name}  global_name: #{global_name}\njoin_list:\n"
    # join_list.get_items.each{ |j|
    #  print "   #{j.get_name} #{j}\n"
    # }

    # Ÿ clone 줿Υꥹȡդ Cell (composite ξ composite  cell  clone)
    clone_cell_list = {}

    #  composite Τ٤Ƥ cell ˤĤ
    @cell_list.get_items.each { |c|

      # debug
      # print "expand : cell #{c.get_name}\n"

      # Join 
      ja = []

      # CompositeCelltype  export ƤӸ°ΥꥹȤˤĤ
      @export_name_list.get_items.each{ |cj|	# cj: CompositeCelltypeJoin

        # debug
        # print "        cj : #{cj.get_name}\n"

        # CompositeCelltypeJoin (export) оݥ뤫
        if cj.match?( c ) then

          # оݥ CompositeCelltype  export  Join (attribute ޤ call port)
          j = join_list.get_item( cj.get_name )

          # debug
          # if j then
          #  print "expand : parent cell: #{name} child cell: #{c.get_name}:  parent's export port: #{cj.get_name}  join: #{j.get_name} #{j}\n"
          # else
          #  print "expand : parent cell: #{name} child cell: #{c.get_name}:  parent's export port: #{cj.get_name}  join: nil\n"
          # end

          if j then
            # ƤӸ°ξ
            #  ComositeCell ѤΤ(j) оݥѤ clone
            jc = j.clone_for_composite

            # debug
            # p "cn #{jc.get_name} #{cj.get_cell_elem_name}"

            # оݥθƤӸޤ°̾ѹ
            jc.change_name( cj.get_cell_elem_name )

            # оݥФ Join 
            ja << jc
          end

          # debug
          # print "\n"
        end
      }

      # debug
      # print "expand : clone #{name}_#{c.get_name}\n"

      #  clone 
#      clone_cell_list[ "#{name}_#{c.get_name}" ] =  c.clone_for_composite( name, global_name, ja )
      clone_cell_list[ "#{c.get_local_name}" ] =  c.clone_for_composite( name, global_name, ja )

    }

    # debug
    # clone_cell_list.each { |nm,c|
    #   print "  cloned: #{nm} = #{c.get_global_name}\n"
    # }

    return clone_cell_list
  end

  def set_specifier( spec )
    spec.each { |s|
      case s
      when :SINGLETON
        @b_singleton = true
      when :IDX_IS_ID
        Generator.warning( "#{@name} : idx_is_id is ineffective for composite celltype" )
      when :ACTIVE
        @b_active = true
      end
    }
  end

  def get_name
    @name
  end

  def get_port_list
    @port_list
  end

  def get_attribute_list
    @attr_list
  end

  def get_var_list
    []   # ֤
  end

  def is_singleton?
    @b_singleton
  end

  def is_active?
    @b_active
  end

  def get_id_base
    raise "get_id_base"
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "CompositeCelltype: name: #{@name}"
    (indent+1).times { print "  " }
    puts "active: #{@b_active}, singleton: #{@b_singleton}"
    @cell_list.show_tree( indent + 1 )
    @export_name_list.show_tree( indent + 1 )
  end

end




class Port
# @name::  str
# @signature:: Signature
# @port_type::  :CALL, :ENTRY
# @array_size:: nil: not array, "[]": sizeless, Integer: sized array
#
# optimize::
# @celltype:: °륻륿
# @ref_port_list[]:: Port[] Ȥݡ (:ENTRY λΤߥåȤ)
#
# :CALL ξκŬ
# @b_VMT_useless:: bool                     # VMT ؿơ֥Ѥʤ
# @b_skelton_useless:: bool                 # ȥؿ   (true λؿƽФ)
# @b_cell_unique:: bool                     # ƤͣΥ
# @only_callee_port:: Port                  # ͣθƤݡ
# @only_callee_cell:: Cell                  # ͣθƤ襻 (@b_PEPDES_in_CB_useless = true λͭ)

  def initialize( name, sig_path, port_type, array_size = nil )
    @name = name
    @port_type = port_type

    if array_size == "[]" then
      @array_size = array_size
    elsif array_size then
      if array_size.kind_of? Expression then
        @array_size = array_size.eval_const(nil)
      else
        @array_size = array_size   # ϥƤӸξʸθƤӸǴɾѤߡ
      end
      if @array_size == nil then
        Generator.error( "Not constant expression #{array_size.to_s}" )
      end

      if Integer( @array_size ) != @array_size then
        Generator.error( "Not Integer #{array_size.to_s}" )
      end

    end

    object = Namespace.find( sig_path )
    if object == nil then
      # mikan signature ̾Դ
      Generator.error( "'#{sig_path}' signature not found" )
    elsif ! object.instance_of?( Signature ) then
      # mikan signature ̾Դ
      Generator.error( "'#{sig_path}' not signature" )
    else
      @signature = object

    end

    @ref_port_list = []

    # call port optimize
    @b_VMT_useless = false                     # VMT  (true λ VMT 𤹤뤳ȤʤƽФ)
    @b_skelton_useless = false                 # ȥؿ   (true λؿƽФ)
    @b_cell_unique = false                     # ͣθƤ襻
    @only_callee_port = nil                    # ͣθƤݡ
    @only_callee_cell = nil                    # ͣθƤ襻

  end

  def set_celltype celltype
    @celltype = celltype
  end

  def get_name
    @name
  end

  def get_port_type
    @port_type
  end

  def ref_port port
    @ref_port_list << port
  end

  def get_signature
    @signature
  end

  def get_array_size
    @array_size
  end

  def get_celltype
    @celltype
  end

  def set_VMT_useless                     # VMT ؿơ֥Ѥʤ
   @b_VMT_useless = true
  end

  def set_skelton_useless                 # ȥؿ   (true λؿƽФ)
    @b_skelton_useless = true
  end

  def set_cell_unique                     # Ƥ襻ϰĤ
    @b_cell_unique = true
  end

  def is_VMT_useless?                     # VMT ؿơ֥Ѥʤ
   @b_VMT_useless
  end

  def is_skelton_useless?                 # ȥؿ   (true λؿƽФ)
    @b_skelton_useless
  end

  def is_cell_unique?                     # ƤΥϰġ
    @b_cell_unique
  end

  #=== ͣη
  #    Ŭǻ
  def set_only_callee( callee_port, callee_cell )
    @only_callee_port = callee_port
    @only_callee_cell = callee_cell
  end

  #=== ͣηݡȤ֤(compositeξ¥)
  def get_real_callee_port
    @only_callee_cell.get_real_port( @only_callee_port.get_name )
  end

  #=== ͣη襻֤(compositeξ¥)
  def get_real_callee_cell
    @only_callee_cell.get_real_cell( @only_callee_port.get_name )
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Port: name: #{@name} port_type: #{@port_type}"
    (indent+1).times { print "  " }
    if @signature then
      puts "signature: #{@signature.get_name}"
    else
      puts "signature: NOT defined"
    end
    if @array_size == "[]" then
      (indent+1).times { print "  " }
      puts "array_size: not specified"
    elsif @array_size then
      (indent+1).times { print "  " }
      puts "array_size: #{@array_size}"
    end
  end

end

class Namespace
# @name::  str
# @path:: name ѥ
# @global_name:: str
# @name_list:: NamedList   Signature,Celltype,CompositeCelltype,Cell,Typedef,Namespace
# @struct_tag_list:: NamedList : StructType
# @namespace_list:: Namespace[]
# @signature_list:: Sginature[]
# @celltype_list:: Celltype[]
# @compositecelltype_list:: CompositeCelltype[]
# @cell_list:: Cell[]@through_generated_list
# @typedef_list:: Typedef[]
# @decl_list:: ( Typedef | StructType | EnumType )[]   ¸طơ֤ɤ˳Ǽ mikan enum
# @const_decl_list:: Decl[]
# @region_list:: Region[]

  # mikan namespace  push, pop

  @@namespace_stack = []      # @@namespace_stack[0] = "::" (generator.rb)
  @@namespace_sp = -1

  def initialize( name )
    @path = Namespace.get_path
    @name = name

    if @@namespace_sp >= 0 then   # root Ͻ
      @@namespace_stack[@@namespace_sp].new_namespace( self )
    end
    @@namespace_sp += 1
    @@namespace_stack[ @@namespace_sp ] = self

    @global_name = Namespace.get_global_name    # stack Ͽ
    @name_list = NamedList.new( nil, "symbol in namespace '#@name'" )
    @struct_tag_list = NamedList.new( nil, "struct tag" )

    @namespace_list = []
    @signature_list = []
    @celltype_list = []
    @compositecelltype_list = []
    @cell_list = []
    @typedef_list = []
    @decl_list = []
    @const_decl_list = []

  end

  def end_of_parse
    @@namespace_sp -= 1
    if @@namespace_sp < 0 then
      raise "StackUnderflow"
    end

  end

  def get_name
    @name
  end

  def self.get_path
    if @@namespace_sp == -1 then
      return ""
    elsif @@namespace_sp == 0 then
      return "::"
    end

    i = 1
    path = ""
    while i <= @@namespace_sp
      path = path+"::"+@@namespace_stack[i]
      i += 1
    end

    path
  end

  def self.get_global_name    # parse ͭ
    if @@namespace_sp <= 0 then
      return ""
    end

    path = @@namespace_stack[1].get_name
    i = 2
    while i <= @@namespace_sp
      path = path+"_"+@@namespace_stack[i].get_name
      i += 1
    end

    path
  end

  # path [ "::", "ns1", "ns2" ]   absolute
  # path [ "ns1", "ns2" ]         relative

  def self.find( path )

    length = path.length
    return self.find_one( path[0] ) if length == 1

    name = path[0]
    if name == "::" then
      i = 1
      name = path[i]   # ʸŪɬ¸
      object = @@namespace_stack[0].find( name )  # root
    else
      i = 0
      object = @@namespace_stack[@@namespace_sp].find( name ) # crrent
    end

    i += 1
    while i < length

      unless object.instance_of?( Namespace ) then
#        if path[i] != nil then		## mikan ɬס
          Generator.error( "'#{name}' not namespace" )
          return nil
#        end
#        return object
      end

      object = object.find( path[i] )
      i += 1
    end

    return object
  end


  def find( name )
    @name_list.get_item(name)
  end

  #===  namespace õĤʤп namespace õ
  def self.find_one( name )

    i = @@namespace_sp
    while i >= 0
      object = @@namespace_stack[i].find( name )
      return object if object != nil
      i -= 1
    end
    return nil

  end

  def self.get_current
    @@namespace_stack[@@namespace_sp]
  end

  def self.find_tag( name )   # mikan tag : namespace  path бʤ
    @@namespace_stack[@@namespace_sp].find_tag( name )
  end

  def find_tag( name )
    @struct_tag_list.get_item( name )
  end

 ### namespace
  def self.new_namespace( namespace )
    @@namespace_stack[@@namespace_sp].new_namespace( namespace )
  end

  def new_namespace( namespace )
    @name_list.add_item( namespace )
    @namespace_list << namespace
  end

 ### signature
  def self.new_signature( signature )
    @@namespace_stack[@@namespace_sp].new_signature( signature )
  end

  def new_signature( signature )
    @name_list.add_item( signature )
    @signature_list << signature
  end

 ### celltype
  def self.new_celltype( celltype )
    @@namespace_stack[@@namespace_sp].new_celltype( celltype )
  end

  def new_celltype( celltype )
    @name_list.add_item( celltype )
    @celltype_list << celltype
  end

 ### compositecelltype
  def self.new_compositecelltype( compositecelltype )
    @@namespace_stack[@@namespace_sp].new_compositecelltype( compositecelltype )
  end

  def new_compositecelltype( compositecelltype )
    @name_list.add_item( compositecelltype )
    @compositecelltype_list << compositecelltype
  end

 ### cell
  def self.new_cell( cell )
    @@namespace_stack[@@namespace_sp].new_cell( cell )
  end

  def new_cell( cell )
    # Ʊ̾Υ֥ȤƤ뤫
    cell_prev = @name_list.get_item( cell.get_name )
    if cell_prev == nil then
      # 
      @name_list.add_item( cell )
      @cell_list << cell
    else
      # Ʊ̾Υ֥Ȥ Cell  ?
      if ! cell_prev.instance_of?( Cell ) then
         Generator.error( "#{cell.get_name}: mismatch with previous one" )
      # celltype פƤ뤫 ?
      elsif cell.get_celltype != cell_prev.get_celltype then
        Generator.error( "#{cell.get_name}: celltype mismatch with previous one" )
      else
        # region פƤ뤫?
        if ! cell_prev.get_region.equal? cell.get_region then
          Generator.error( "#{cell.get_name} region '#{cell.get_region.get_name}' mismatch  with previous one '#{cell_prev.get_region.get_name}'" )
        end

        # ϴ˺ѤǤ뤫
        if cell_prev.get_f_def == true then

          # Ʊ cell Ф 2ٸƽФ뤿ᡢƱ cell ̵
          if ( ! cell_prev.equal? cell ) && cell.get_f_def == true then
            Generator.error( "#{cell.get_name}: duplicate" )
          # else
          # θ˥ץȥʤ줿ʻȤ뤳ȤϤʤ̵
          end
        else

          # ץȥʤС򴹡ʰΤΤ񤭡
          cell.add_prototype cell_prev
          @name_list.change_item( cell )
          @cell_list = @cell_list - [cell_prev]
          @cell_list << cell
        end
      end
    end
  end

  def check_ref_but_undef
    @cell_list.each { |c|
      if ! c.get_f_def then
        if c.get_f_ref then
          Generator.error( "#{c.get_global_name} : undefined cell" )
        elsif $verbose then
          Generator.warning( "#{c.get_global_name} : only prototype, unused and undefined cell" )
        end
      end
    }
    @namespace_list.each { |n|
      n.check_ref_but_undef
    }
  end

 ### struct
  def self.new_structtype( struct )
    @@namespace_stack[@@namespace_sp].new_structtype( struct )
  end

  def new_structtype( struct )
    @struct_tag_list.add_item( struct )
    @decl_list << struct
  end

 ### typedef
  def self.new_typedef( typedef )
    @@namespace_stack[@@namespace_sp].new_typedef( typedef )
  end

  def new_typedef( typedef )
    @name_list.add_item( typedef )
    @typedef_list << typedef
    @decl_list << typedef
  end

  def self.is_typename?( str )
    i = @@namespace_sp
    while i >= 0
      if @@namespace_stack[i].is_typename?( str ) then
        return true
      end
      i -= 1
    end
    false
  end

  def is_typename?( str )
    if @name_list.get_item( str ).instance_of?( Typedef ) then
      true
    else
      false
    end
  end

 ### const_decl
  def self.new_const_decl( decl )
    @@namespace_stack[@@namespace_sp].new_const_decl( decl )
  end

  def new_const_decl( decl )
    if ! decl.is_const? then			# const Ƥ뤳
      Generator.error( "#{decl.get_name}: not constant" )
    elsif ! decl.is_type?( IntType ) && ! decl.is_type?( FloatType ) then
                                            # IntType, FloatType Ǥ뤳
      Generator.error( "#{decl.get_name}: should be int or float type" )
    elsif decl.get_initializer == nil then   # ͤĤ
      Generator.error( "#{decl.get_name}: has no initializer" )
    elsif decl.get_initializer.eval_const(nil) == nil then
                                            # mikan ͤФŬڤǤ뤳
      Generator.error( "#{decl.get_name}: has unsuitable initializer" )
    else
      @name_list.add_item( decl )
      @const_decl_list << decl
    end

  end

 ### region
  def self.new_region( region )
    @@namespace_stack[@@namespace_sp].new_region( region )
  end

  def new_region( region )
    @name_list.add_item( region )
  end

 ###

  def show_tree( indent )
    indent.times { print "  " }
    puts "Namespace: name: #{@name} path: #{@path}"
    @struct_tag_list.show_tree( indent + 1 )
    @name_list.show_tree( indent + 1 )
  end

end


class Join
# @name:: string
# @subscript:: nil: not array, -1: subscript not specified, >=0: array_subscript
# @rhs:: Expression | initializer ( array of Expression | initializer )
# @definition:: Port, Decl(attribute or var)
# @namespace:: Namespace
#
# available if definition is Port
# @cell_name:: string : դΥ̾
# @cell:: Cell  : դΥ
# @celltype:: Celltype : դΥ륿
# @port_name:: string : դμ̾
# @port:: Port : դμ
# @array_member:: rhs array : available only for first appear in the same name
# @array_member2:: Join array : available only for first appear in the same name
# @through_list:: [ [ plugin_name1, plugin_arg ], [ plugin_name2, plugin_arg ], ... ]
# @through_generated_list:: [ Plugin_class object, ... ]
#
# @@loaded_plugin_list:: {bool}
# @@newed_plugin_cell_count:: = {int}

  @@loaded_plugin_list = {}
  @@newed_plugin_cell_count = {}

  def initialize( name, subscript, rhs )
    @name = name
    @namespace = Namespace.get_current
    if subscript.instance_of?( Expression ) then
       #mikan źǤ뤳Ȥ̤å
       @subscript = subscript.eval_const(nil)
       if @subscript == nil then
         Generator.error( "array subscript not constant" )
       end
    else
       @subscript = subscript
    end

    @rhs = rhs

    if @subscript != nil then
      @array_member  = [@rhs]
      @array_member2 = [self]
    end

    Cell.new_join( self )
  end

  #===  Join դб celltype ꤹȤȤ˥å
  # STAGE:   S
  #
  #     ǽå
  #definition:: Decl (attribute,varλ) ޤ Port (callλ) ޤ nil (definition Ĥʤä)

  def set_definition( definition )

    @definition = definition

    # mikan ͤ͡ηåʤ
    if @definition.instance_of?( Decl ) then

      # attribute, var ξ
      if @definition.get_kind == :ATTRIBUTE then
#        check_cell_cb_init( definition.type, @rhs )
         # դǽǽå
         definition.type.check_init( definition.identifier, @rhs, :ATTRIBUTE )
      elsif @definition.get_kind == :VAR then
        # var ϽǤʤ
        Generator.error( "cannot initialize var" )
      else
        # Bug trap
        raise "UnknownDeclKind"
      end
    elsif @definition.instance_of?( Port ) then
      ### Port

      # դϼʼ褦ȤƤˡ
      if @definition.get_port_type == :ENTRY then
         Generator.error( "'#{@name}' cannot initialize entry port" );
         return
      end

      @through_list = []
      @through_generated_list = []

      # mikan Expression  get_type ǷƳФޡ
      # mikan '=' κդ󤫤ɤ̤å
      #(1) '=' αդ "Cell.ePort" η
      #     黻Ҥ "."   "." κդ :IDENTIFIER
      #     "." αդϥå (synatax Ū :IDENTIFIER)
      #(2) "Cell" ¸ߤ뤫̾פΤϤ뤫
      #(3) "Cell"  cell 
      #(4) "Cell"  celltype ͭ (̵ʤ˥顼
      #(5) "ePort"  "Cell"  celltype ¸ߤ뤫
      #(6) "ePort"  entry port 
      #(7) signature ϰפ뤫

      # դʤʰʳǥ顼
      return unless @rhs

      # դ Expression ǤФ
      elements = @rhs.get_elements
      if elements[0] == :OP_SUBSC then  # ա
        subscript = elements[2].eval_const(nil)  # ź
        elements  = elements[1]          # mikan ä
        array     = true
      else
        array = false
      end

      if elements[0] != :OP_DOT || elements[1][0] != :IDENTIFIER then   #(1)
        Generator.error( "rhs not 'Cell.ePort' form" )
        return
      end

      @cell_name = elements[1][1].val
      @port_name = elements[2].val

      # composite ʤ object Ϸ cell Ĥʤ nil ֤
      # composite ʤ false ֤
      object = CompositeCelltype.find( @cell_name )
      if object == false then
#       mikan դ namespace бƤʤᡣ path ˤ find
#       object = Namespace.find( @cell_name )
        object = Namespace.find( [ @cell_name ] )
        in_composite = false
      else
        in_composite = true
      end

      if object == nil then                                             # (2)
        Generator.error( "'#{@cell_name}' not found" )
      elsif ! object.instance_of?( Cell ) then                          # (3)
        Generator.error( "'#{@cell_name}' not cell" )
      else
        # դΥ򻲾ȺѤߤˤ
        object.set_f_ref

        # դΥΥ륿
        celltype = object.get_celltype

        if celltype then                                                # (4)
          object2 = celltype.find( @port_name )
          if object2 == nil then                                        # (5)
            Generator.error( "'#{@port_name}' not found" )
          elsif ! object2.instance_of? Port \
               || object2.get_port_type != :ENTRY then                  # (6)
            Generator.error( "'#{@port_name}' not entry port" )
          elsif @definition.get_signature != object2.get_signature then # (7)
            Generator.error( "'#{@port_name}' signature mismatch" )
          elsif object2.get_array_size then
            # 

            unless array then
              # դź꤬ʤä
              Generator.error( "'#{@port_name}' should be array" )
            else

              as = object2.get_array_size
              if( as.kind_of?( Integer ) && as <= subscript )then
                 # 礭ФդźƱ礭
                 Generator.error( "#{@port_name}[#{subscript}]: subscript out of range (< #{as})" )
              else
#                puts "Join OK!"
                @cell = object
                @celltype = celltype
                # object2: Port, @definition: Port
                object2.ref_port @definition
                @port = object2
              end

               # debug
               # print "Join set_definition: rhs: #{@cell}  #{@cell.get_name}\n"

            end
          elsif array then
              # ǤʤΤ˱դźꤵƤ
              Generator.error( "'#{@port_name}' entry port is not array" )
          else
#            puts "Join OK!"

            @cell = object
            @celltype = celltype

            # object2: Port, @definition: Port
            object2.ref_port @definition
            @port = object2

            # debug
            # p "rhs:  #{@cell}  #{@cell.get_name}"
          end  # end of port (object2) å

        #else
        #  celltype == nil (Ǥ˥顼)
        end  # end of celltyep å

        create_allocator_join( object )
        check_region( object )

      end  # end of cell (object) å

    elsif @definition == nil then
      Generator.error( "'#@name' not in celltype" )

    else
      raise "UnknownToken"
    end
  end

  #=== η
  #cell::  ƤӸηΥ
  #
  #  a[*] Ƥ cell  set_specifier_list 򻲾
  def create_allocator_join( cell )
    if( cell.get_allocator_list ) then
      cell.get_allocator_list.each { |a|
        if( a[0] == @port_name && a[1] == @subscript  )then
          # ̾ΰפΤη
          # ­ϡӥå
          cp_name = "#{@name}_#{a[2]}_#{a[3]}"
          # p "#{cp_name} #{@subscript} #{a[1]}"
          Join.new( cp_name, @subscript, a[4] )
        end
      }
    end
  end

  @@in_through_count = 0
  @@out_through_count = 0
  @@to_through_count = 0

  def check_region( object )

    if Generator.get_nest >= 1 then
# p "check_region #{@name} not"
      return
    end

# p "check_region #{@name}"

    # region Υå
    r1 = Region.get_current     # ƤӸ region
    r2 = object.get_region      #  region

    if ! r1.equal? r2 then      # Ʊ region ʤƽФǽ

      # mikan namespace б
      f1 = r1.get_family_line
      len1 = f1.length
      f2 = r2.get_family_line
      len2 = f2.length

      # ԰פˤʤȤʷˤõ
      i = 1  # i = 0  :RootRegion ʤΤɬ
      while( i < len1 && i < len2 )
        if( f1[i] != f2[i] )then
          break
        end
        i += 1
      end

      sibling_level = i     # Ȥʤ٥롢⤷Ϥɤ餫ä٥

      # p "silibing_level: #{i}"
      # p "from: #{f1[i].get_name}" if f1[i]
      # p "to: #{f2[i].get_name}" if f2[i]

      # Ƥ¦ˤĤƸƤӸΥ٥뤫鷻٥ޤǡout_through å
      i = len1 -1
      while i >= sibling_level
        # print "going out from #{f1[i].get_name} level=#{i}\n"
        out_through_list = f1[i].get_out_through_list   # [ plugin_name, plugin_arg ]
        if out_through_list.length == 0 then
          Generator.error( "#{@name}: going out from region '#{f1[i].get_name}' not permitted" )
        end
        out_through_list.each { |ol|
          if ol[0] then    # plugin_nmae ꤵƤʤϿʤ
            through = [ ol[0], "Join_out_through__#{@@out_through_count}", ol[1] ]
            @through_list << through
            @@out_through_count += 1
          end
        }
        i -= 1
      end

      # ٥ˤơto_through å
      if f1[sibling_level] && f2[sibling_level] then
        # print "going from #{f1[sibling_level].get_name} to #{f2[sibling_level].get_name}\n"
        found = 0
        f1[sibling_level].get_to_through_list.each { |t|
          if t[0][0] == f2[sibling_level].get_name then   # region ̾פ뤫 ?
          # mikan namespace бƤʤ (RootNamespace ˤʤưʤ)
            if t[1] then    # plugin_nmae ꤵƤʤϿʤ
              through = [ t[1], "Join_to_through__#{@@to_through_count}", t[1] ]
              @through_list << through
              @@to_through_count += 1
            end
            found = 1
          end
          if found == 0 then
            Generator.error( "#{@name}: going from region '#{f1[sibling_level].get_name}' to #{f2[sibling_level].get_name}' not permitted" )
          end
        }
      end

      # ¦ˤĤƷ٥뤫¦Υ٥ޤǡin_through å
      i = sibling_level
      while i < len2
        # print "going in to #{f2[i].get_name} level=#{i}\n"
        in_through_list = f2[i].get_in_through_list   # [ plugin_name, plugin_arg ]
        if in_through_list.length == 0 then
          Generator.error( "#{@name}: going in to region '#{f2[i].get_name}' not permitted" )
        end
        in_through_list.each { |il|
          if il[0] then    # plugin_nmae ꤵƤʤϿʤ
            through = [ il[0], "Join_in_through__#{@@in_through_count}", il[1] ]
            @through_list << through
            @@in_through_count += 1
          end
        }
        i += 1
      end

    end
  end

  def get_definition
    @definition
  end

  def set_specifier_list( specifier_list )

# p "set_spec"

    specifier_list.each { |s|
      case s[0]
      when :THROUGH
        if ! @definition.instance_of? Port then
          Generator.error( "#{@name} : not port: 'through' can be specified only for port" )
        else

          # set plugin_name
          plugin_name = s[1].to_s
          plugin_name[0] = "#{plugin_name[/^./].upcase}"     # Ƭʸʸ : ruby Υ饹̾

          # set cell_name
          count = @@newed_plugin_cell_count[ plugin_name ]
                # ruby Ǥʸʸ̤ʤᡢʸ plugin_name ź˻Ȥ
          count = 0 if count == nil
          @@newed_plugin_cell_count[ plugin_name ] = count + 1
          cell_name = "#{s[1].to_s}_#{count}"

          # set plugin_arg
          plugin_arg = s[2].to_s.gsub( /^"(.*)"$/, '\1' )   #  "" 

          @through_list << [ plugin_name, cell_name, plugin_arg ]

        end
      end
    }

    if @definition.instance_of? Port then
      check_and_gen_through
    end
  end

  def check_and_gen_through

# p "check_and_gen_through"

    if @through_list then           # nil when the join is not Port
      len = @through_list.length
    else
      len = 0
    end

    i = len - 1
    while i >= 0

      through = @through_list[ i ]
      plugin_name           = through[ 0 ]
      generating_cell_name  = through[ 1 ]
      plugin_arg            = through[ 2 ]

      if i != len - 1 then
        next_cell_name        = @through_list[ i + 1 ][ 1 ]

        begin
          next_port_name      = @through_generated_list[ i + 1 ].get_through_entry_port_name
        rescue
          Generator.error( "#{plugin_name}: plugin function failed: 'get_through_entry_port_name'" )
          i -= 1
          next
        end

      else
        # ǸΥξ硢Υ̾ݡ̾
        next_cell_name      = @cell_name
        next_port_name      = @port_name
      end

      load_plugin( plugin_name )
      gen_through_cell_code_and_parse( plugin_name, i, next_cell_name, next_port_name )
      i -= 1
    end
  end

  def load_plugin( plugin_name )
    begin
      unless @@loaded_plugin_list[ "#{plugin_name}.rb" ] then
        @@loaded_plugin_list[ "#{plugin_name}.rb" ] = true
        if ( $verbose ) then
          print( "load '#{plugin_name}.rb'\n" )
        end
        # "#{plugin_name}.rb" ɡʥƥѤǤϤʤΤǡfatal 顼ˤʤ
        require_tecsgen_lib( "#{plugin_name}.rb", false )
      end
    rescue   # mikan rescue  require 㳰ªǤʤΤϤʤ
             # mikan plugin ΥեΥɤ˼ԤȤΥ顼åޤɽǤʤ
      Generator.error( "#{plugin_name}.rb : fail to load plugin" )

    end
  end

  def gen_through_cell_code_and_parse( plugin_name, i, next_cell_name, next_port_name )

    through = @through_list[ i ]
    plugin_name           = through[ 0 ]
    generating_cell_name  = through[ 1 ]
    plugin_arg            = through[ 2 ]

    begin
      plugin_object = nil
      eval_str = "plugin_object = #{plugin_name}.new( '#{generating_cell_name}', '#{plugin_arg}', '#{next_cell_name}', '#{next_port_name}', '#{@definition.get_signature.get_name}', @celltype )"
      if $verbose then
        print "new through: #{eval_str}\n"
      end

      eval ( eval_str )     # plugin 
      @through_generated_list[ i ] = plugin_object

      tmp_file_name = "#{$gen}/tmp_#{plugin_name}_#{generating_cell_name}_#{@@newed_plugin_cell_count[ plugin_name ]}.cdl"

      begin
        tmp_file = File.open( tmp_file_name, "w" )
        begin
          @through_generated_list[ i ].gen_through_cell_code( tmp_file )
        rescue
          if $debug then
            print "stack trace\n"
            p $@
          end

          Generator.error( "#{plugin_name}: plugin error in gen_through_cell_code" )
        end
        begin
          tmp_file.close
        rescue
          Generator.error( "#{plugin_name}: close error '#{tmp_file_name}'" )
        end
      rescue
        Generator.error( "#{plugin_name}: open error '#{tmp_file_name}'" )
      end

      generator = Generator.new
      generator.set_plugin( plugin_object )
      generator.parse( [ tmp_file_name ] )
      generator.finalize

    rescue => evar
      Generator.error( "#{plugin_name}: fail to new" )

      print "eval( #{eval_str} )\n"
      print "#{evar}\n"
      if $debug then
        print "stack trace\n"
        p $@
      end
    end
  end

  def get_name
    @name
  end

  def get_subscript
    @subscript
  end

  def get_cell_name         # ̾
    @cell_name
  end

  def get_celltype
    @celltype
  end

  def get_cell
    @cell
  end

  #=== դμ¥
  #    ¥Ȥ through 줿Ρcomposite ʤɼºݤ˷礵
  #    Υ᥽åɤϡget_rhs_port ФˤʤäƤ
  def get_rhs_cell
    # through ꤢꡩ
    if @through_list[0] then
      # mikan through Τ root namespace 
      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )
      return cell.get_real_cell( @through_generated_list[0].get_through_entry_port_name )
    else
      return @cell.get_real_cell( @port_name )
    end
  end

  def get_cell_global_name  # ̾ʥݥåȤʤŸ¦Υ

    # debug
    # print "cell get_cell_global_name:  #{@cell_name}\n"
    # @cell.show_tree( 1 )

    # cell = @namespace.find( @cell_name )
    return @cell.get_real_global_name( @port_name )

  end

  #===  αդμ̾
  #     namespace ̾ + '_' + ̾ + '_' + ̾   ʤΥ뤬 composite ʤŸΥ̾̾
  #subscript:: Integer  ƤӸλź ޤ nil ƤӸǤʤ
  def get_port_global_name( subscript = nil )  # ̾ʥݥåȤʤŸ¦Υ

    # debug
    # print "Cell get_port_global_name:  #{@cell_name}\n"

    # cell = @namespace.find( @cell_name )

    # through ꤢꡩ
    if @through_list[0] then

      # mikan through Τ root namespace 
      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )

      # through 줿ǡºݤ³륻compositeξ)μ C ̾
      return cell.get_real_global_port_name( @through_generated_list[0].get_through_entry_port_name )
    else

      # ºݤ³륻μ C ̾
      return @cell.get_real_global_port_name( @port_name )

    end

  end

  def get_port_name
    @port_name
  end

  def get_rhs
    @rhs
  end

  #=== դΥݡȤ
  #    դ composite ξϡηҤ륻Υݡ, through ξ줿Υݡ
  #    Υ᥽åɤ get_rhs_cell ФˤʤäƤ
  def get_rhs_port
    # through ꤢꡩ
    if @through_list[0] then
      # mikan through Τ root namespace 
      # through 줿õ
      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )
      # cell Υץ饰줿ݡ̾ΥݡȤõ (composite ʤηҤݡ)
      return cell.get_real_port( @through_generated_list[0].get_through_entry_port_name )
    else
      # ݡȤ֤(composite ʤηҤݡȤ֤)
      return @cell.get_real_port( @port_name )
    end
  end


  #=== ƤӸ2ܰʹߤǤɲä
  #     ֺǽ줿ǤǤνͤ
  #     Υ᥽åɤξƽФjoin ʣ顼ξ
  #join2:: Join  ƤӸǤ Join
  def add_array_member join2

    # subscript2: join2 κź
    subscript2 = join2.get_subscript

    if @subscript == nil then		# not array : initialize duplicate
      # ξ硢join ʣƤ
      Generator.error( "'#@name' duplicate" )

    elsif @subscript >= 0 then
      # źꤢξ
      if( subscript2 == nil || subscript2 < 0 ) then
        # join2 դޤźʤ
        # ԰
        Generator.error( "'#@name' inconsistent array definition" )
      elsif @array_member[subscript2] != nil then
        # ƱźѤ
        Generator.error( "'#@name' redefinition of subscript #{subscript2}" )
      else
        # źΰ֤Ǥɲ
        @array_member[subscript2] = join2.get_rhs
        @array_member2[subscript2] = join2
#        p "0:#{join2.get_rhs}"
      end

    else
      # źʤξ
      if( subscript2 == nil || subscript >= 0 ) then
        # join2 դޤźͭ
        # ԰
        Generator.error( "'#@name' inconsistent array definition" )
      end

      # źʤξ硢Ǥɲ
      @array_member  << join2.get_rhs
      @array_member2 << join2
    end
  end

  def get_array_member
    @array_member
  end

  def get_array_member2
    @array_member2
  end

  def change_name name
    # debug
    # print "change_name: #{@name} to #{name}\n"

    @name = name

    if @array_member2 then
      i = 1
      while i < @array_member2.length
        @array_member2[i].change_name( name )
        i += 1
      end
    end
  end

  # composite cell Ÿη clone ̾ѹ
  def change_rhs_port( clone_cell_list, celltype )

    # debug
    # print "change_rhs name: #{@name}  cell_name: #{@cell_name} #{@cell}\n"

    # debug
    # clone_cell_list.each{ |cell, ce|
    #   print "change_rhs:  #{cell.get_name}=#{cell} : #{ce.get_name}\n"
    # }

    c = clone_cell_list[@cell]
    return if c == nil

    # debug
    # print "  cell_name:   #{@cell_name} => #{c.get_global_name}\n"

    @cell_name = c.get_name
    @cell = c

    if @array_member2 then

      # debug
      # p "array_member2.len : #{@array_member.length}"

      @array_member2[0] = self
      i = 1    # 0 ܤǤ self äƤΤ1ܰʹߤǤ clone
      while i < @array_member2.length
        @array_member2[i].change_rhs_port( clone_cell_list, celltype )
        i += 1
      end
    end

  end

  def clone_for_composite

    # debug
    # print "join.clone_for_composite : #{@name} #{@cell_name} #{self}\n"
    cl = self.clone

    if @array_member2 then
      cl.clone_array_member( @array_member, @array_member2 )
    end

    # debug
    # print "join cloned : #{cl}\n"
    return cl
  end

  def clone_array_member( array_member, array_member2 )
    am  = array_member.clone
    am2 = array_member2.clone

    # i = 0 ϼʬȤǤʤΤǡƽФ̵ºƵƽФȤʤ
    i = 1
    while i < am2.length
      am2[i] = array_member2[i].clone_for_composite

      # debug
      # p "clone_array_member: #{@name} #{am2[i]} #{array_member2[i]}"

      i += 1
    end

    # i = 0 ϡǼʬȤ
    am2[0] = self

    @array_member  = am
    @array_member2 = am2

  end

  #=== rhs 촹
  #rhs:: Expression | initializer
  # դ촹롥
  # Υ᥽åɤϡcomposite  cell °νͤ attribute ֤ͤΤ˻Ȥ
  # Υ᥽åɤ composite  cell °νͤǤϤʤˤʤä硢פˤʤ
  def change_rhs rhs
    @rhs = rhs
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Join: name: #{@name} global_name: #{@global_name} id: #{self}"
    if @subscript == nil then
    elsif @subscript >= 0 then
      (indent+1).times { print "  " }
      puts "subscript: #{@subscript}"
    else
      (indent+1).times { print "  " }
      puts "subscript: not specified"
    end
    (indent+1).times { print "  " }
    puts "rhs: "
    if @rhs.instance_of?( Array )then
      @rhs.each{ |i|
        if i.instance_of?( Array )then
          i.each{ |j|
            j.show_tree( indent + 3 )
          }
        else
          i.show_tree( indent + 2 )
        end
      }
    else
      @rhs.show_tree( indent + 2 )
      (indent+1).times { print "  " }
      if @definition then
        puts "definition:"
        @definition.show_tree( indent + 2 )
      else
        puts "definition: not found"
      end
    end
    if @definition.instance_of?( Port ) then
      (indent+2).times { print "  " }
      puts "cell: #{@cell_name}  port: #{@port_name}  cell_global_name: #{@cell.get_global_name}"
    end
    if @through_list then
      i = 0
      @through_list.each { |t|
        (indent+2).times { print "  " }
        puts "through: plugin name :  '#{t[0]}' arg : '#{t[1]}'"
        @through_generated_list[i].show_tree( indent+3 )
        i += 1
      }
    end
    if @array_member2 then
      (indent+1).times { print "  " }
      puts "array member:"
      i = 0
      @array_member2.each { |j|
        (indent+2).times { print "  " }
        puts "[#{i}]: #{j.get_name}  id: #{j}"
        j.get_rhs.show_tree(indent+3)
        (indent+3).times { print "  " }
        puts "cell global name: #{j.get_cell_global_name}"
        (indent+3).times { print "  " }
        puts "port global name: #{j.get_port_global_name}"
        i += 1
      }
    end
  end

end


# CLASS: CompositeCelltype Ѥ Join
# REM:   CompositeCelltype  export 
class CompositeCelltypeJoin
# @export_name:: string     :  CompositeCelltype  export ̾ʸƤӸ°
# @internal_cell_name:: string : CompositeCelltype Υ̾
# @internal_cell_elem_name:: string : CompositeCelltype ΥθƤӸ°̾
# @cell : Cell : Cell::  internal cell  : CompositeCelltyep Υin_composite
# @port_decl:: Port | Decl

  def initialize( export_name, internal_cell_name,
		 internal_cell_elem_name, cell, port_decl )
    @export_name = export_name
    @internal_cell_name = internal_cell_name
    @internal_cell_elem_name = internal_cell_elem_name
    @cell = cell
    @port_decl = port_decl

  end

  #=== CompositeCelltypeJoin оݥ뤫
  #cell::  Cell оݤɤå륻
  #
  #     CompositeCelltypeJoin  cell ̾פ뤫å
  #     port_decl ꤵ줿ϡȤƤʤ
  def match?( cell, port_decl = nil )

    #debug
    #if port_decl
    #  printf( "@cell:      %-20s      %08x\n", @cell.get_name, @cell.object_id )
    #  printf( "@port_decl: %-20s      %08x\n", @port_decl.get_name, @port_decl.object_id )
    #  printf( "cell:       %-20s      %08x\n", cell.get_name, cell.object_id )
    #  printf( "port_decl:  %-20s      %08x\n", port_decl.get_name, port_decl.object_id )
    #end

    if port_decl then

      # debug
      # print "   cell_name: #{cell.get_name.class}=#{cell.get_name} cell_elem_name: #{port_decl.get_name.class}=#{port_decl.get_name}\n"
      # print "   @cell_name: #{@cell.get_name.class}=#{@cell.get_name} cell_elem_name: #{@port_decl.get_name.class}=#{@port_decl.get_name}\n"

    end


#    if @cell.equal?( cell ) && ( port_decl == nil || @port_decl.equal?( port_decl ) ) then
    # ʤ port_decl פʤФʤʤä˺줿
    # recursive_composite ̾ΰפѹ   060917
    if((@cell.get_name == cell.get_name) && (port_decl == nil || @port_decl.get_name == port_decl.get_name))then
      true
    else
      false
    end
  end

  def check_dup_init
    return if get_port_type != :CALL

    if @cell.get_join_list.get_item @internal_cell_elem_name then
      Generator.error( "'#{@internal_cell_name}.#{@internal_cell_elem_name}' has duplicate initializer" )
    end
  end

  def get_name
    @export_name
  end

  def get_cell_name
    @internal_cell_name
  end

  def get_cell
    @cell
  end

  def get_cell_elem_name
    @internal_cell_elem_name
  end

  def get_port_type
    @port_decl.get_port_type
  end

  def get_port_decl
    @port_decl
  end

  def get_size_is
    @port_decl.get_size_is
  end

  #=== 󥵥
  #RETURN:: nil: not array, "[]": 礭ʤ, Integer: 礭ꤢ
  def get_array_size
    @port_decl.get_array_size
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "CompositeCelltypeJoin: export_name: #{@export_name}"
    (indent+1).times { print "  " }
    puts "internal_cell_name: #{@internal_cell_name}"
    (indent+1).times { print "  " }
    puts "internal_cell_elem_name: #{@internal_cell_elem_name}"
  end
end

class Factory
# @name:: string
# @file_name:: string
# @format:: string
# @arg_list:: Expression  elements Ʊ [ [:IDENTIFIER, String], ... ]
# @f_celltype:: bool : true: celltype factory, false: cell factory

  @@f_celltype = false

  def initialize( name, file_name, format, arg_list )
    @f_celltype = @@f_celltype

    case name
    when :write
      # write ؿ
      @name = name

      # write ؿե̾
        # ɾ̾ñʸǤ뤫顢ñʸ֤
      @file_name = file_name.eval_const(nil).val  # file_name : Expression
      if ! @file_name.instance_of?( String ) then
        # ʸǤϤʤä
        Generator.error( "#{@name}: 1st parameter is not string(file name)" )
        @file_name = nil
      end

      # write ؿեޥåʸ
      @format    = format.eval_const(nil).val     # format : Expression
        # ɾ̾ñʸǤ뤫顢ñʸ֤
      if ! @format.instance_of?( String ) then
        # ʸǤϤʤä
        Generator.error( "#{@name}: 2nd parameter is not string(fromat)" )
        @format = nil
      end

      # 軰ʹߤꥹȤȤ mikan Υå
      @arg_list = arg_list

    else
      Generator.error( "#{name}: unknown factory function" )
    end
    Celltype.new_factory( self )
  end

  def check_arg( celltype )
    if ! @arg_list then
      return
    end

    if @f_celltype then
      Generator.error( "celltype factory can't have parameter(s)" )
      return
    end

    @arg_list.each{ |elements|

      case elements[0]
      when :IDENTIFIER
        obj = celltype.find( elements[1] )
        if obj == nil then
          Generator.error( "'#{elements[1]}': not found" )
        elsif ! obj.instance_of?( Decl ) || obj.get_kind != :ATTRIBUTE then
          Generator.error( "'#{elements[1]}': not attribute" )
        end
      when :STRING_LITERAL
      else
        Generator.error( "internal error Factory.check_arg()" )
      end

    }
  end

  def self.set_f_celltype( f_celltype )
    @@f_celltype = f_celltype
  end

  def get_f_celltype
    @f_celltype
  end

  def get_name
    @name
  end

  def get_file_name
    @file_name
  end

  def get_format
    @format
  end

  def get_arg_list
    @arg_list
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Factory: name: #{@name}"
    if @arg_list then
      (indent+1).times { print "  " }
      puts "argument(s):"
      @arg_list.each { |l|
        (indent+2).times { print "  " }
        print "\"#{l}\"\n"
      }
    end
  end
end

class Region
# @name:: string
# @family_line:: [ @region_root, ...,@region_me ]  ȷ
# @in_through_list:: [ [ plugin_name, plugin_arg ], ... ] : plungin_name = nil λ in ػ
# @out_through_list:: [ [ plugin_name, plugin_arg ], ... ] : plungin_name = nil λ out ػ
# @to_through_list:: [ [ dst_region, plugin_name, plugin_arg ], ... ]

  # Generator  nest  (RootRegionΤȤ=0, through,in/out/to_throughƤȤ > 0)
  @@region_nest_count = -1

  # region å (¾βսǤ stack  Generator  nest  push 뤿ѤƤ㤷Ƥ)
  @@region_stack_sp = -1
  @@region_stack = []

  @@in_through_list  = []
  @@out_through_list = []
  @@to_through_list  = []

  # Region 򤷤ʤin_through,out_through,to_through줿cellˤregionŬѤʤ
  def self.push
    @@region_nest_count += 1
  end

  def self.pop
    @@region_nest_count -= 1
  end

  def initialize( name )

    @name = name

    @@region_stack_sp += 1

    # mikan name  Namespace 
    object = Namespace.find( [ name ] )
    if object then
      if object.instance_of?( Region ) then
        # ƽи
        @@region_stack[@@region_stack_sp] = object

        # ƽи specifier ꤵƤ뤫
        if( @@in_through_list.length != 0 || @@out_through_list.length != 0 || @@to_through_list.length != 0 )then
          Generator.error( "#{name}: region specifier must place at first appearence" )
        end

      else
        # ۤʤƱ̾Υ֥ȤѤ
        Generator.error( "#{name} duplication, previous one : #{object.class}" )
        @@region_stack[@@region_stack_sp] = self    # 顼 region
      end
    else
      # и
      @@region_stack[@@region_stack_sp] = self

      # ʣˤɲ
      @family_line = @@region_stack[0,@@region_stack_sp+1].dup

      Namespace.new_region( self )

      @in_through_list  = @@in_through_list
      @out_through_list = @@out_through_list
      @to_through_list  = @@to_through_list

    end    

    @@in_through_list  = []
    @@out_through_list = []
    @@to_through_list  = []


# p @name
# p @in_through_list
# p @out_through_list
# p @to_through_list

  end

  def self.end_of_parse
    @@region_stack_sp -= 1
    if @@region_stack_sp == -2 then
      raise "RegionStackUnderflow"  # never come here
    end
  end

  def self.new_in_through( plugin_name = nil, plugin_arg = nil )
    @@in_through_list << [ plugin_name, plugin_arg ]
  end

  def self.new_out_through( plugin_name = nil, plugin_arg = nil )
    @@out_through_list << [ plugin_name, plugin_arg ]
  end

  def self.new_to_through( dst_region, plugin_name, plugin_arg )
    # p "New to_through #{dst_region}"
    @@to_through_list  << [ dst_region, plugin_name, plugin_arg ]
  end

  def get_name
    @name
  end

  def get_family_line
    @family_line
  end

  def get_in_through_list
    @in_through_list
  end

  def get_out_through_list
    @out_through_list
  end

  def get_to_through_list
    @to_through_list
  end

  def get_path_string
    pstring = ""
    @family_line.each{ |p|
      pstring = "#{pstring}:#{p.get_name}"
    }
    pstring
  end

  def self.get_current
    @@region_stack[@@region_stack_sp]
  end

  def show_tree( indent )
    indent.times { print( "  " ) }
    puts "Region: name: #{@name}"
    (indent+1).times { print( "  " ) }
    puts "path: #{get_path_string}"
  end
end

class Import_C

  # إå̾ʸΥꥹ
  @@header_list = []
  @@header_path_list = []

  def initialize( header, define = "" )

    # إåե̾ʸ󤫤 "" 
    header = header.to_s.gsub( /^"(.*)"$/, '\1' )

    if define != "" then
      # ","  -D ֤
      def_opt = define.gsub( /,/, " -D " )

      # Ƭ -D  # mikan Ŭڤ define Ϥä硢CPP ˥顼
      def_opt = def_opt.gsub( /^/, "-D " )

    end

    $define.each{ |define|
      def_opt = "#{$def_op} -D #{define}"
    }

    include_opt = ""
    found = false
    header_path = ""
    $import_path.each{ |path|
      include_opt = "#{include_opt} -I #{path}"
      if found == false then
        begin
          # ե stat äƤߤ(ʤ㳰ȯ)
          File.stat( "#{path}/#{header}" )

          # cdl 򸫤Ĥäեѥ˺
          header_path = "#{path}/#{header}"
          found = true
        rescue
          found = false
        end
      end
    }

    if found == false then
      Generator.error( "#{header} not found in search path" )
      return
    end

    # إåΥꥹȤϿ
    @@header_list << header
    @@header_path_list << header_path

    begin
      tmp_C = "#{$gen}/tmp_C_src.c"
      file = open( tmp_C, "w" )
    rescue
      Generator.error( "#{tmp_C}: temporary C source: open error" )
    end

    begin
      file.print( "#include \"#{header}\"\n" )
    rescue
      Generator.error( "#{tmp_C}: temporary C source: writing error" )
    ensure
      file.close
    end

    # CPP  tmp ե̾
    tmp_header = header.gsub( /\//, "_" )
    tmp_header = "#{$gen}/tmp_#{tmp_header}"

    # CPP ޥɥ饤
    cmd = "#{$cpp} #{def_opt} #{include_opt} #{tmp_C}"

    begin
      if( $verbose )then
        puts "CPP: #{cmd}"
      end

      # ץץåޥɤ pipe ȤƳ
      cpp = IO.popen( cmd, "r" )
      begin
        tmp_file = nil
        tmp_file = File.open( tmp_header, "w" )
        cpp.each { |line|
          line = line.gsub( /^#(.*)$/, '/* \1 */' )
          tmp_file.puts( line )
        }
      rescue
        Generator.error( "#{header}: error occured while CPP" )
      ensure
        tmp_file.close if tmp_file    # mikan File.open ˼Ԥ tmp_file == nil ݾڤƤ ?
        cpp.close
      end
    rescue
      Generator.error( "#{header}: popen for CPP failed" )
    end

    # C Υѡ󥹥󥹤
    c_parser = C_parser.new

    # tmp_header ѡ
    c_parser.parse( [tmp_header] )

    # ѡå᤹
    c_parser.finalize

  end

  def self.get_header_list
    @@header_list
  end

  def self.get_header_path_list
    @@header_path_list
  end
end

class Import

  # إå̾ʸΥꥹ
  @@cdl_list = {}

  def initialize( cdl )

    # إåե̾ʸ󤫤 "" n
    cdl = cdl.to_s.gsub( /^"(.*)"$/, '\1' )

    # ѥõ
    found = false
    cdl_path = ""
    $import_path.each{ |path|
       begin
         # ե stat äƤߤ(ʤ㳰ȯ)
         File.stat( "#{path}/#{cdl}" )

         # cdl 򸫤Ĥäեѥ˺
         cdl_path = "#{path}/#{cdl}"
         found = true
         break
       rescue
         found = false
       end
    }

    if found == false then
      Generator.error( "#{cdl} not found in search path" )
      return
    end

    # ɹߺѤߤʤ顢ɹޤʤ
    return if( @@cdl_list[ cdl ] )

    # إåΥꥹȤϿ
    @@cdl_list[ cdl ] = cdl_path

    # ѡ󥹥󥹤(̥ѡɤ߹)
    parser = Generator.new

    # cdl ѡ
    parser.parse( [cdl_path] )

    # ѡå᤹
    parser.finalize

  end

  def self.get_cdl_list
    @@cdl_list
  end

end

